unit DGOptionsForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  DGTypes, DGCompilerThread, Contnrs, Dialogs, ToolsAPI, StdActns,
  ActnList, ExtCtrls, StdCtrls, ComCtrls, Buttons, AppEvnts;

{$I DGExperts.inc}

type
  TDgCustomControl = class(TCustomControl);

  TfrmOptions = class(TForm)
    ActionList: TActionList;
    BevelGutter: TBevel;
    BevelMatch: TBevel;
    BlockMatchDelayUpDown: TUpDown;
    BlockMatchLineWidthUpDown: TUpDown;
    btnAddSource: TBitBtn;
    btnAddUnit: TBitBtn;
    btnApply: TBitBtn;
    btnCancel: TBitBtn;
    btnDelSource: TBitBtn;
    btnDelUnit: TBitBtn;
    btnGutterFont: TBitBtn;
    btnLaunchDelphiTemplateEditor: TButton;
    btnOKSave: TBitBtn;
    btnParseDelphiTemplates: TButton;
    btnSelCompileBin: TBitBtn;
    btnSelTempDir: TBitBtn;
    cbAutoReInstallGutter: TCheckBox;
    cbBlockMatchBold: TCheckBox;
    cbBlockMatchItalic: TCheckBox;
    cbBlockMatchStyle: TComboBox;
    cbBlockMatchUseHotkey: TCheckBox;
    cbBracketMatchBold: TCheckBox;
    cbBracketMatchCurrentLine: TCheckBox;
    cbEnableBlockMatch: TCheckBox;
    cbEnableBracketMatch: TCheckBox;
    cbEnableCodeTemplate: TCheckBox;
    cbEnableEnhanceGutter: TCheckBox;
    cbEnableTokenMatch: TCheckBox;
    cbShowBookmark: TCheckBox;
    cbShowCurrentLineImage: TCheckBox;
    cbShowError: TCheckBox;
    cbShowKeyword: TCheckBox;
    cbShowLineNumber: TCheckBox;
    cbShowQuestion: TCheckBox;
    cbSyntaxError: TCheckBox;
    ColorDialog: TColorDialog;
    DelphiApplicationEvents: TApplicationEvents;
    DlgSyntaxError: TOpenDialog;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditDelete1: TEditDelete;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    edtAddtional: TLabeledEdit;
    edtBlockMatchDelay: TEdit;
    edtCompileBin: TLabeledEdit;
    edtGutterWidth: TEdit;
    edtMatchLineWidth: TEdit;
    edtSyntaxInterval: TEdit;
    edtTempDir: TLabeledEdit;
    edtTemplateDescription: TEdit;
    FontDialog: TFontDialog;
    gbBlockMatch: TGroupBox;
    gbBookmark: TGroupBox;
    gbBracketMatch: TGroupBox;
    gbGutterImage: TGroupBox;
    gbGutterLineNumber: TGroupBox;
    GutterWidthUpDown: TUpDown;
    imgBookmark: TImage;
    imgCurrentLine: TImage;
    imgError: TImage;
    imgGutterPreview: TImage;
    imgKeyword: TImage;
    imgQuestion: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lblBlockMatchDelay: TLabel;
    lblBlockMatchWidth: TLabel;
    lbSources: TListBox;
    lbTemplateKeywords: TListBox;
    lbUnits: TListBox;
    memoTemplateContent: TMemo;
    PageControl: TPageControl;
    paneBlock1: TPanel;
    paneBlock2: TPanel;
    paneBlock3: TPanel;
    paneBlock4: TPanel;
    paneBlock5: TPanel;
    paneBlock6: TPanel;
    paneBlock7: TPanel;
    paneBookmark: TPanel;
    paneBracketMatch: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    PanelBottom: TPanel;
    paneLineNumberDefault: TPanel;
    panePreview: TPanel;
    pbGutterPreview: TPaintBox;
    pbMatchPreview: TPaintBox;
    Splitter1: TSplitter;
    SyntaxIntervalUpDown: TUpDown;
    TimerCount: TTimer;
    TimerFindEdtPropWnd: TTimer;
    TimerGutterAnimate: TTimer;
    TimerInstallCallback: TTimer;
    TimerInstallGutter: TTimer;
    tsCodeTemplate: TTabSheet;
    tsEnhanceGutter: TTabSheet;
    tsSyntaxError: TTabSheet;
    tsTokenMatch: TTabSheet;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnGutterFontClick(Sender: TObject);
    procedure btnOKSaveClick(Sender: TObject);
    procedure cbEnableBlockMatchClick(Sender: TObject);
    procedure cbEnableBracketMatchClick(Sender: TObject);
    procedure cbEnableEnhanceGutterClick(Sender: TObject);
    procedure cbEnableTokenMatchClick(Sender: TObject);
    procedure cbShowLineNumberClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure pbGutterPreviewPaint(Sender: TObject);
    procedure TimerGutterAnimateTimer(Sender: TObject);
    procedure TimerInstallCallbackTimer(Sender: TObject);
    procedure TimerInstallGutterTimer(Sender: TObject);
    procedure pbMatchPreviewPaint(Sender: TObject);
    procedure TimerCountTimer(Sender: TObject);
    procedure cbBlockMatchUseHotkeyClick(Sender: TObject);
    procedure cbBlockMatchStyleSelect(Sender: TObject);
    procedure btnAddSourceClick(Sender: TObject);
    procedure btnDelSourceClick(Sender: TObject);
    procedure btnAddUnitClick(Sender: TObject);
    procedure btnDelUnitClick(Sender: TObject);
    procedure btnSelCompileBinClick(Sender: TObject);
    procedure cbSyntaxErrorClick(Sender: TObject);
    procedure btnSelTempDirClick(Sender: TObject);
    procedure btnParseDelphiTemplatesClick(Sender: TObject);
    procedure lbTemplateKeywordsClick(Sender: TObject);
    procedure lbTemplateKeywordsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnLaunchDelphiTemplateEditorClick(Sender: TObject);
    procedure TimerFindEdtPropWndTimer(Sender: TObject);
  private
    FEditWndProc, FPrevEditWndProc: TFarProc;
    FEditControl: TDgCustomControl;
    FEnhanceGutter: TDGEnhanceGutter;
    FOnDelphiRepaint: Boolean;
    FOnTemplateAction: Boolean;
    FOnTemplateActionCursorPos: TOTAEditPos;
    FBookmarks: TObjectQueue;
    FTokenMatchPreview: TBitmap;
    FGutterPreview1: TBitmap;
    FGutterPreview2: TBitmap;
    FHintWindow: TDgHintWindow;
    FSaveHintWindowLine: Integer;
    function GetCursorPos: TOTAEditPos;
    function GetEditControl: TDgCustomControl;
    procedure SetCursorPos(const Value: TOTAEditPos);
    { Private declarations }
  protected
    SyntaxThread: TDGCompiler;
    //  WndProc Handler
    procedure EditWndProc(var WindowMsg: TMessage);
    procedure EditWndProcKeyDown(var WindowMsg: TMessage; var TrapMessage: Boolean);
    procedure EditWndProcKeyUp(var WindowMsg: TMessage; var TrapMessage: Boolean);
    procedure EditWndProcPaint(var WindowMsg: TMessage; var TrapMessage: Boolean);
    //  WM_PAINT Handler
    procedure DelphiEditPaintEx;
    procedure DelphiEditPaintBookmark(EditView: IOTAEditView; EditBuffer: IOTAEditBuffer);
    procedure DelphiEditPaintBlockMatch(EditView: IOTAEditView; EditBuffer: IOTAEditBuffer);
    procedure DelphiEditPaintBlockMatchEx(List: TObjectList);
    procedure DelphiEditPaintBracketMatch(EditView: IOTAEditView; EditBuffer: IOTAEditBuffer);
    procedure DelphiEditPaintGutter;
    procedure WMGetMinMaxInfo(var WindowMsg: TMessage); message WM_GETMINMAXINFO;
    // Sndkey32
    function TemplateContentToEdit(TemplateContent: string): TOTAEditPosArray;
    //  Gutter Button Click Event
    procedure OnSpeedButton1Click(Sender: TObject);
    procedure OnSpeedButton2Click(Sender: TObject);
    procedure OnEnhanceGutterClick(Sender: TObject);
    procedure OnEnhanceGutterMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  public
    Options: TDgOptions;
    Errors: TObjectList; // TThreadList;
    //  Properties
    property EditControl: TDgCustomControl read GetEditControl;
    property CursorPos: TOTAEditPos read GetCursorPos write SetCursorPos;
    property Bookmarks: TObjectQueue read FBookmarks write FBookmarks;
    procedure DoCodeTemplateAction;
    procedure StartCallback;
    procedure StopCallback;
    procedure InstallGutter;
    procedure UninstallGutter;
  published
    procedure OnColorPanelClick(Sender: TObject);
    procedure OnColorPanelRightClick(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
  end;

implementation

uses TypInfo, DGUtils, mwPasLexTypes, DGGotoLineForm, StrUtils, Clipbrd;

var
  AnimateIndex: Integer;

  SaveHintPause, SaveHintHidePause: Integer;
  SaveEditBrush, SaveEditFont: TColor;
  NowTime: TDateTime;

  AutoVarString: string;

  GutterWidth,
    TopRow, BottomRow,
    LeftColumn, RightColumn,
    TextWidth, TextHeight: Integer;

{$R *.dfm}
{$R DG.RES}

procedure _AutoDeclare(const lnStr: string);
var
  EditView: IOTAEditView;
  StartPos, TempPos: TOTAEditPos;
  VarToken, MethodEndToken: TPasToken;

  procedure _BackwardFindDeclarePos();
  var
    i: Integer;
    TempToken: TPasToken;
    RoundOpen, RoundClose: Boolean;
  begin
    RoundOpen := False;
    RoundClose := False;
    for i := SourceParser.MethodStartToken.ItemIndex + 1 to SourceParser.MethodCloseToken.ItemIndex do
    begin
      TempToken := TPasToken(SourceParser.Tokens.Items[i]);
      //if i < SourceParser.MethodCloseToken.ItemIndex then
      //begin
      //  NextTempToken := TPasToken(SourceParser.Tokens.Items[i + 1]);
      //  if NextTempToken.TokenID in [ptStdcall, ptSafeCall, ptPascal, ptRegister,
      //    ptCdecl, ptOverload, ptOverride, ptReintroduce, ptVirtual] then
      //    Continue;
      //end;

      if TempToken.TokenID = ptRoundOpen then RoundOpen := True;
      if TempToken.TokenID = ptRoundClose then RoundClose := True;

      if (TempToken.Token = ';') and (RoundClose or (not RoundOpen)) and (not Assigned(MethodEndToken)) then
        MethodEndToken := TempToken;

      if (TempToken.TokenID = ptVar) and Assigned(MethodEndToken) then
        VarToken := TempToken;

      if (TempToken.TokenID in [ptBegin, ptFunction, ptProcedure]) then
      begin
        Assert(Assigned(MethodEndToken));
        Break;
      end;
    end;
  end;

begin
  EditView := OTAGetCurrentEditView;
  VarToken := nil;
  MethodEndToken := nil;

  if (not Assigned(EditView)) then Exit;
  try
    if OTAGetCursorPos(StartPos) then
    begin
      SourceParser.ParseCurrentSource;
      try
        SourceParser.FindCurrentMethodBlock;
      except
      end;
      //  Assign VarToken and MethodEndToken
      _BackwardFindDeclarePos;

      if Assigned(VarToken) then
      begin
        TempPos.Line := VarToken.LineNumber + 1;
        TempPos.Col := VarToken.ColNumber + VarToken.TokenLen + 1;
        EditView.SetCursorPos(TempPos);
        OTAEditInsertText(#13#10);
        EditView.Position.MoveBOL;
        OTAEditInsertText(#9 + lnStr);
        if RightStr(lnStr, 1) <> ';' then OTAEditInsertText(';');
        Inc(StartPos.Line);
      end
      else if Assigned(MethodEndToken) then
      begin
        TempPos.Line := MethodEndToken.LineNumber + 1;
        TempPos.Col := MethodEndToken.ColNumber + 2;
        EditView.SetCursorPos(TempPos);
        OTAEditInsertText(#13#10);
        EditView.Position.MoveBOL;
        OTAEditInsertText('var' + #13#10#9);
        OTAEditInsertText(lnStr);
        if RightStr(lnStr, 1) <> ';' then OTAEditInsertText(';');
        Inc(StartPos.Line, 2);
      end;
      OTASetCursorPos(StartPos);
      EditView.MoveViewToCursor;
      EditView.Paint;
    end;
  finally
    EditView := nil;
    VarToken := nil;
    MethodEndToken := nil;
  end;
end;

procedure _InputVar(const inStr: string);
var
  InputString: string;
  EndPos: Integer;
begin
  InputString := inStr;
  if InputQuery('Variable Declare', 'Input Text will insert into Method-Var Part.', InputString) then
  begin
    InputString := Trim(InputString);
    _AutoDeclare(InputString);
    EndPos := Pos(':', InputString);
    if EndPos > 0 then
    begin
      AutoVarString := Copy(InputString, 1, EndPos - 1);
      //  Clipboard.AsText := VarString;
    end;
  end;
end;

function _PrepareTemplateContent(const TemplateContent: string): string;
const
  CRLF = #13#10;
  Tab = #9;
var
  EditBuffer: IOTAEditBuffer;
  SystemUserName, FileName, ProjectFileName: string;
  ActiveProject: IOTAProject;
begin
  EditBuffer := OTAGetCurrentEditBuffer;
  try
    SourceParser.FindCurrentMethodBlock;
  except
  end;

  SystemUserName := GetCurrentUser;
  ActiveProject := GetActiveProject;

  if Assigned(EditBuffer) then
    FileName := ExtractFileName(EditBuffer.FileName);
  if Assigned(ActiveProject) then
    ProjectFileName := ExtractFileName(ActiveProject.FileName);

  Result := TemplateContent;
  Result := AnsiReplaceText(Result, PDDATE, DateToStr(Now()));
  Result := AnsiReplaceText(Result, PDTIME, TimeToStr(Now()));
  Result := AnsiReplaceText(Result, PDFILE, FileName);
  Result := AnsiReplaceText(Result, PDCLIPBOARD, Clipboard.AsText);
  Result := AnsiReplaceText(Result, PDPROJECT, ProjectFileName);
  Result := AnsiReplaceText(Result, PDMETHOD, SourceParser._MethodName);
  Result := AnsiReplaceText(Result, PDUSERNAME, SystemUserName);

  ActiveProject := nil;
end;

function TfrmOptions.TemplateContentToEdit(TemplateContent: string): TOTAEditPosArray;
var
  EditView: IOTAEditView;
  EditBuffer: IOTAEditBuffer;
  tmp, autoVarStr, inputVarStr, TemplateText: string;
  i, BookmarkCount, EndPos, Size: Integer;
  myFlag: Boolean;
  TempResult: TOTAEditPosArray;
begin
  EditView := OTAGetCurrentEditView;
  EditBuffer := OTAGetCurrentEditBuffer;
  if (not Assigned(EditView)) or (not Assigned(EditBuffer)) then Exit;

  SetLength(TempResult, 256);
  try
    TemplateText := _PrepareTemplateContent(TemplateContent);
  except
    Debug('Prepare Template Exception ...', TemplateContent);
    Debug;
    TemplateText := TemplateContent;
  end;
  Debug('Prepared Template', TemplateText);

  try
    //  Send Template
    i := 1;
    BookmarkCount := 0;
    myFlag := False;
    Size := Length(TemplateText);
    while i <= Size do
    begin
      if TemplateText[i] = '|' then
      begin
        OTAEditInsertText(tmp);
        tmp := '';
        OTAGetCursorPos(TempResult[BookmarkCount].Line, TempResult[BookmarkCount].Col);
        BookmarkCount := BookmarkCount + 1;
        //OTAEditInsertText(' ');
      end
      else if (Ord(TemplateText[i]) = 13) then
      begin
        //  Return Key here.
        OTAEditInsertText(tmp);
        tmp := '';
        OTAEditInsertText(#13#10);
        FOnTemplateActionCursorPos.Line := CursorPos.Line;
        CursorPos := FOnTemplateActionCursorPos;
        EditView.Paint;
      end
      else if (Ord(TemplateText[i]) = 10) then
      begin
        //  Do nothing.
      end
      else if (TemplateText[i] = '<') then
      begin
        myFlag := True;
      end
      else if (myFlag and (TemplateText[i] = '-')) then
      begin // '<-' Backspace key
        EditView.Position.BackspaceDelete(1);
        EditView.Paint;
        myFlag := False;
      end
      else if (myFlag and (TemplateText[i] = '>')) then
      begin // '<>' EOL
        EditView.Position.MoveEOL;
        EditView.Paint;
        myFlag := False;
      end
      else if (myFlag and (TemplateText[i] = '<')) then
      begin // '<<' BOL
        EditView.Position.MoveBOL;
        EditView.Paint;
        myFlag := False;
      end
      else if (myFlag and (TemplateText[i] = 'x')) then
      begin // '<x' DELETE
        EditView.Position.Delete(1);
        myFlag := False;
      end
      else if (myFlag and (TemplateText[i] = ' ')) then
      begin // '< .... ....'
        //  i = 2,
        if (i = 2) or (Ord(TemplateText[i - 2]) = 10) then
        begin
          EndPos := PosEx(#13#10, TemplateText, i);
          if EndPos > 0 then
          begin
            autoVarStr := Trim(Copy(TemplateText, i, EndPos - i));
            i := EndPos + 1;
          end
          else if EndPos <= 0 then
          begin
            autoVarStr := Trim(Copy(TemplateText, i, Size - i));
            i := Size;
          end;
          // Auro Declear Variables
          Debug('Auto-Declare Variables', autoVarStr);
          if isNotNull(autoVarStr) then _AutoDeclare(autoVarStr);
          myFlag := False;
        end;
      end
      else if (myFlag and (TemplateText[i] = '?')) then
      begin // '<?.... ....'
        //  i = 2 Start, or #13#10 follow
        if (i = 2) or (Ord(TemplateText[i - 2]) = 10) then
        begin
          EndPos := PosEx(#13#10, TemplateText, i);
          if EndPos > 0 then
          begin
            inputVarStr := Trim(Copy(TemplateText, i + 1, EndPos - i));
            i := EndPos + 1;
          end
          else if EndPos <= 0 then
          begin
            inputVarStr := Trim(Copy(TemplateText, i + 1, Size - i));
            i := Size;
          end;
          // Auro Declear Variables
          Debug('Input Variables', inputVarStr);
          if isNotNull(inputVarStr) then _InputVar(inputVarStr);
          myFlag := False;
        end;
      end
      else
      begin
        tmp := tmp + TemplateText[i];
      end;

      Inc(i);
    end;
    OTAEditInsertText(tmp);

    //  Packed Result
    SetLength(Result, BookmarkCount);
    for i := 0 to BookmarkCount - 1 do
    begin
      Result[i].Col := TempResult[i].Col;
      Result[i].Line := TempResult[i].Line;
    end;
  finally
    EditView := nil;
    EditBuffer := nil;
  end;
end;

procedure _RestoreColor(EditControl: TDgCustomControl);
begin
  if Assigned(EditControl) then
  begin
    EditControl.Canvas.Brush.Color := SaveEditBrush;
    EditControl.Canvas.Font.Color := SaveEditFont;
    EditControl.Canvas.Font.Style := [];
  end;
end;

procedure _SaveColor(EditControl: TDgCustomControl);
begin
  if Assigned(EditControl) then
  begin
    SaveEditBrush := EditControl.Canvas.Brush.Color;
    SaveEditFont := EditControl.Canvas.Font.Color;
  end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmOptions.InstallGutter;
begin
  if Options.Gutters.Enabled and Assigned(EditControl) then
  begin
    if (not Assigned(FEditControl)) or (not EditControl.Parent.Visible) then
    begin
      UninstallGutter;
      Self.TimerInstallGutter.Enabled := True;
    end
    else
    begin
      if not Assigned(FEnhanceGutter) then
      begin
        FEnhanceGutter := TDgEnhanceGutter.Create(Self);
        FEnhanceGutter.Width := Options.Gutters.GutterWidth;
        FEnhanceGutter.OnSpeedBtn1ClickEvent := OnSpeedButton1Click;
        FEnhanceGutter.OnSpeedBtn2ClickEvent := OnSpeedButton2Click;
        FEnhanceGutter.OnPaintBoxClickEvent := OnEnhanceGutterClick;
        FEnhanceGutter.OnPaintBoxMouseMoveEvent := OnEnhanceGutterMouseMove;
      end;

      try
        FEnhanceGutter.Parent := FEditControl.Parent;
        with FEnhanceGutter.PaintBox, Options.Gutters do
        begin
          ParentFont := False;
          Font.Name := LineNumberFontName;
          Font.Size := LineNumberFontSize;
          Font.Color := LineNumberFontColor;
        end;
        EditControl.Parent.Refresh;
        //DelphiEditPaintEx;
        Debug('Install Gutter Success.');
      except
        Debug('Install Gutter Failed Exception ....');
        Debug();
        UninstallGutter;
        if Options.Gutters.AutoReInstall then
          TimerInstallGutter.Enabled := True
        else
        begin
          Options.Gutters.Enabled := False;
          TimerInstallGutter.Enabled := False;
        end;
      end;
    end;
  end;
end;

procedure TfrmOptions.UninstallGutter;
begin
  try
    if Assigned(FEnhanceGutter) then
      FreeAndNil(FEnhanceGutter);
  except
    Debug('Uninstall Gatter Exception ...');
    Debug;
  end;

  FEnhanceGutter := nil;
  TimerInstallGutter.Enabled := False;
end;

procedure TfrmOptions.TimerInstallGutterTimer(Sender: TObject);
begin
  if Assigned(FEnhanceGutter) or (not Options.Gutters.Enabled) then
    TimerInstallGutter.Enabled := False
  else
  begin
    InstallGutter;
  end;
end;

procedure TfrmOptions.StartCallback;
begin
  if FOnTemplateAction then Exit;
  StopCallback;

  if Assigned(EditControl) then
  begin
    try
      InstallGutter;
    except
      Debug('Install Gatter Exception ...');
      Debug;
      UninstallGutter;
    end;

    try
      if Syntaxthread.Suspended and Options.Syntaxs.Enabled then SyntaxThread.Resume;
    except
    end;

    FEditWndProc := Classes.MakeObjectInstance(EditWndProc);
    FPrevEditWndProc := TFarProc(GetWindowLong(EditControl.Handle, GWL_WNDPROC));
    SetWindowLong(EditControl.Handle, GWL_WNDPROC, Integer(FEditWndProc));
    Debug('>>> Start Windows Message Callback ...');
    DebugAddSeparator;
  end
  else
    TimerInstallCallback.Enabled := True;
end;

procedure TfrmOptions.StopCallback;
begin
  if FOnTemplateAction then Exit;
  try
    if (not Syntaxthread.Suspended) then SyntaxThread.Suspend;
  except
  end;

  while Bookmarks.Count > 0 do
    Bookmarks.Pop.Free;

  try
    if Assigned(FPrevEditWndProc) then
    begin
      SetWindowLong(EditControl.Handle, GWL_WNDPROC, Integer(FPrevEditWndProc));
      Debug('<<< Stop Windows Message Callback ...');
    end;

    if Assigned(FEditWndProc) then
      Classes.FreeObjectInstance(FEditWndProc);
  except
    Debug('Stop Callback Exception ...');
    Debug;
  end;
  FEditWndProc := nil;
  FPrevEditWndProc := nil;
  FEditControl := nil;
end;

procedure TfrmOptions.TimerInstallCallbackTimer(Sender: TObject);
begin
  if not Assigned(FPrevEditWndProc) then
    StartCallback
  else
    TimerInstallCallback.Enabled := False;
end;

procedure TfrmOptions.DoCodeTemplateAction;
var
  EditView: IOTAEditView;
  EditBuffer: IOTAEditBuffer;
  LineText: string;
  TemplateKey, TemplateContent: string;
  PosArray: TOTAEditPosArray;
  EditPos: TOTAEditPos;
  i: Integer;
begin
  if (FOnTemplateAction) then Exit;
  if not Assigned(EditControl) then Exit;

  EditView := OTAGetCurrentEditView;
  EditBuffer := OTAGetCurrentEditBuffer;
  if (not Assigned(EditView)) or (not Assigned(EditBuffer)) then Exit;
  DebugEnterMethod('DoCodeTemplateAcion');

  try
    LineText := GetStrProp(EditControl, 'LineText');
    Debug('LineText', LineText);
    if isAllowTemplateRun(LineText, CursorPos.Col) then
    begin
      TemplateKey := AheadCursorText(LineText, CursorPos.Col);
      TemplateContent := Options.Templates.GetTemplateContentFromKey(TemplateKey);
      Debug('TemplateKey', TemplateKey);
      Debug('TemplateContent', TemplateContent);

      if Length(TemplateContent) > 0 then
      begin
        FOnTemplateAction := True;

        //  Delete the Template Key
        EditView.Position.BackspaceDelete(Length(TemplateKey) + 1);
        EditView.Paint;

        //  Saving Cursor Start Template Pos
        FOnTemplateActionCursorPos := EditView.CursorPos;

        //  Send Template Content in EditView here.
        try
          PosArray := TemplateContentToEdit(TemplateContent);

          //  Locate the first "|" position.
          if Length(PosArray) > 0 then
          begin
            EditPos.Line := PosArray[0].Line;
            EditPos.Col := PosArray[0].Col;
            CursorPos := EditPos;
          end;

          //  Save other "|" psition as Bookmark.
          for i := Low(PosArray) + 1 to High(PosArray) do
            FBookmarks.Push(TDgBookmark.Create(PosArray[i].Line, PosArray[i].Col));
          EditControl.Refresh;
        except
          ;
        end;
        FOnTemplateAction := False;
      end
    end;
  finally
    EditView := nil;
    EditBuffer := nil;
    DebugExitMethod();
  end;
end;

procedure TfrmOptions.EditWndProc(var WindowMsg: TMessage);
var
  TrapMessage: Boolean;
begin
  TrapMessage := False;
  with WindowMsg do
  begin
    if (Msg = WM_KEYUP) then
      EditWndProcKeyUp(WindowMsg, TrapMessage)
    else if (Msg = WM_KEYDOWN) then
      EditWndProcKeyDown(WindowMsg, TrapMessage)
    else if (Msg = WM_PAINT) or (Msg = WM_VSCROLL) or (Msg = WM_HSCROLL) or (Msg = WM_MOUSEWHEEL) then
      EditWndProcPaint(WindowMsg, TrapMessage);

    if (not FOnDelphiRepaint) and (not TrapMessage) and
      Assigned(EditControl) and Assigned(FPrevEditWndProc) then
      Result := CallWindowProc(FPrevEditWndProc, EditControl.Handle, Msg, wParam, lParam);
  end;
end;

procedure TfrmOptions.EditWndProcKeyDown(var WindowMsg: TMessage; var TrapMessage: Boolean);
begin
  //
end;

procedure TfrmOptions.EditWndProcKeyUp(var WindowMsg: TMessage; var TrapMessage: Boolean);
var
  EditView: IOTAEditView;
  EditBuffer: IOTAEditBuffer;
  i, Count: Integer;
  bookmark: TDGBookmark;
  CurrentCursorPos: TOTAEditPos;
begin
  EditControl.Refresh;
  DelphiEditPaintEx;
  if (not Assigned(EditControl)) then Exit;

  with WindowMsg do
  begin
    {  When user press the Special Template_Action_key, do Template Action }
    if Options.Templates.Enabled and (not FOnTemplateAction) and
      (wParam = CODE_TEMPLATE_ACTION_KEY) then
    try
      DoCodeTemplateAction;
    except
    end;

    if (not FOnTemplateAction) and (wParam = LOCATE_FIRST_BOOKMARK_ACTION_KEY) and (Bookmarks.Count > 0) then
    begin
      TrapMessage := True;
      bookmark := TDgBookmark(Bookmarks.Pop);
      OTASetCursorPos(bookmark.Line, bookmark.Col);
      FreeAndNil(bookmark);
      bookmark := nil;
      EditView := OTAGetCurrentEditView;
      try
        if Assigned(EditView) then EditView.MoveViewToCursor;
      finally
        EditView := nil;
      end;
    end
    else if (not FOnTemplateAction) and (Bookmarks.Count > 0) then //  Adjust Bookmarks Position
    begin
      CurrentCursorPos := CursorPos;
      Count := Bookmarks.Count - 1;
      for i := 0 to Count do
      begin
        bookmark := TDgBookmark(Bookmarks.Pop);
        if (bookmark.Line > CurrentCursorPos.Line) and (wParam = VK_RETURN) then
        begin
          bookmark.Line := bookmark.Line + 1;
        end
        else if ((bookmark.Line = CurrentCursorPos.Line) and (bookmark.Col >= CurrentCursorPos.Col)) then
        begin
          if (wParam = VK_BACK) or (wParam = VK_DELETE) then
            bookmark.Col := bookmark.Col - 1
          else if ((wParam >= 32) and (wParam < 128)) then // Visual ASCII
            bookmark.Col := bookmark.Col + 1;
        end;
        Bookmarks.Push(bookmark);
      end;
    end;

    EditControl.Refresh;

    if Options.Matchs.BlockMatchUseHotkey and (wParam = SHOW_BLOCK_MATCH_ACTION_KEY) then
    begin
      try
        if Assigned(EditControl) then
        begin
          _SaveColor(EditControl);
          try
            EditView := OTAGetCurrentEditView;
            EditBuffer := OTAGetCurrentEditBuffer;
            if Assigned(EditView) and Assigned(EditBuffer) then
              Self.DelphiEditPaintBlockMatch(EditView, EditBuffer);
          finally
            EditView := nil;
            EditBuffer := nil;
            _RestoreColor(EditControl);
          end;
        end;
      except
        ;
      end;
    end;
  end;
  DelphiEditPaintEx;
end;

procedure TfrmOptions.EditWndProcPaint(var WindowMsg: TMessage; var TrapMessage: Boolean);
begin
  TrapMessage := True;
  if FOnDelphiRepaint then
    WindowMsg.Result := 0
  else if Assigned(EditControl) and Assigned(FPrevEditWndProc) then
  begin
    WindowMsg.Result := CallWindowProc(FPrevEditWndProc, EditControl.Handle, WindowMsg.Msg, WindowMsg.wParam, WindowMsg.lParam);
    DelphiEditPaintEx;
  end
  else
    TrapMessage := False;
end;

procedure TfrmOptions.DelphiEditPaintBlockMatch(EditView: IOTAEditView; EditBuffer: IOTAEditBuffer);
var
  KeyTokenList: TObjectList;
  i: Integer;
  TempToken: TPasToken;
begin
  if FOnTemplateAction then Exit;
  if not isPascalFile(EditBuffer.FileName) then Exit;
  if not Options.Matchs.Enabled then Exit;
  if not Options.Matchs.EnableBlockMatch then Exit;

  //  Parsing Source Structure if need it.
  if ((SourceParser.FileName <> EditBuffer.FileName) or (EditBuffer.Modified)) then
  begin
    SourceParser.ParseCurrentSource;
  end;

  try
    SourceParser.FindCurrentMethodBlock;
  except
    ;
  end;

  if Assigned(SourceParser.MethodStartToken) and Assigned(SourceParser.MethodCloseToken) then
  begin
    with SourceParser do
    begin
      KeyTokenList := TObjectList.Create(False);
      try
        for i := MethodStartToken.ItemIndex + 1 to MethodCloseToken.ItemIndex - 1 do
        begin
          TempToken := TPasToken(Tokens[i]);
          case TempToken.TokenID of
            ptIf, ptThen,
              ptFor, ptWith, ptOn, ptWhile, ptDo,
              ptAsm, ptBegin, ptEnd,
              ptTry, ptExcept, ptFinally,
              ptCase,
              ptRepeat, ptUntil:
              KeyTokenList.Add(TempToken);
          end;
        end;
        KeyTokenList.Add(MethodClosetoken);
        DelphiEditPaintBlockMatchEx(KeyTokenList);
      finally
        FreeAndNil(KeyTokenList);
      end;
    end;
  end;
end;

procedure TfrmOptions.DelphiEditPaintBlockMatchEx(List: TObjectList);
var
  i, Count: Integer;
  TempToken, AheadToken: TPasToken;
  Stack: TObjectStack;

  procedure _DrawDotLine(StartPos, EndPos: TPoint);
  var
    j: integer;
    TopLeft, BottomRight: TPoint;
  begin
{$IFDEF TOKEN_MATCHED_DOTLINE_STYLE}
    if DOTLINE_INTERVAL <= 0 then
    begin
      EditControl.Canvas.FillRect(Rect(StartPos, EndPos));
    end
    else
    begin
      for j := 0 to ((EndPos.Y - StartPos.Y) div (DOTLINE_STEP + DOTLINE_INTERVAL)) do
      begin
        TopLeft.X := StartPos.X;
        TopLeft.Y := StartPos.Y + j * (DOTLINE_STEP + DOTLINE_INTERVAL);

        BottomRight.X := EndPos.X;
        BottomRight.Y := TopLeft.Y + DOTLINE_STEP;

        EditControl.Canvas.FillRect(Rect(TopLeft, BottomRight));
      end;
    end;
{$ELSE}
    EditControl.Canvas.FillRect(Rect(StartPos, EndPos));
{$ENDIF}
  end;

  procedure _DrawTokenMatch(StartToken, EndToken: TPasToken);
  var
    TopLeft, BottomRight, TempPoint: TPoint;
    ColorLayer: Integer;
  begin
{$IFDEF SAME_LINE_TOKEN_MATCHED}
    if EndToken.LineNumber < StartToken.LineNumber then Exit;
{$ELSE}
    if EndToken.LineNumber <= StartToken.LineNumber then Exit;
{$ENDIF}

    TopLeft.X := GutterWidth + TextWidth * (StartToken.ColNumber + 1 - LeftColumn);
    TopLeft.Y := TextHeight * (StartToken.LineNumber + 2 - TopRow);

    BottomRight.X := GutterWidth + TextWidth * (EndToken.ColNumber + 1 - LeftColumn);
    BottomRight.Y := TextHeight * (EndToken.LineNumber + 2 - TopRow);

    if BottomRight.X <= TopLeft.X then
      TopLeft.X := BottomRight.X - Options.Matchs.EnableBlockMatchLineWidth
    else
      BottomRight.X := TopLeft.X + Options.Matchs.EnableBlockMatchLineWidth;

    ColorLayer := (StartToken.ItemLayer mod 7);
    case ColorLayer of
      1: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground1;
      2: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground2;
      3: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground3;
      4: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground4;
      5: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground5;
      6: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground6;
      0: EditControl.Canvas.Brush.Color := Options.Matchs.BlockForeground7;
    end;
    {
    Line
    Area
    Line Highlighter
    Area Highlighter
    Highlighter
    }
    if Options.Matchs.BlockMatchLineStyle in [0, 2] then
    begin
      BottomRight.Y := BottomRight.Y - TextHeight;
      if (TopLeft.X >= GutterWidth - 5) then _DrawDotLine(TopLeft, BottomRight);
    end
    else if Options.Matchs.BlockMatchLineStyle in [1, 3] then
    begin
      if (TopLeft.X >= GutterWidth - 5) then _DrawDotLine(TopLeft, BottomRight);

      TempPoint := Point(TopLeft.X + TextWidth * StartToken.TokenLen, TopLeft.Y + Options.Matchs.EnableBlockMatchLineWidth);
      if (TopLeft.X >= GutterWidth - 5) then EditControl.Canvas.FillRect(Rect(TopLeft, TempPoint));

      BottomRight.X := BottomRight.X - Options.Matchs.EnableBlockMatchLineWidth;
      TempPoint := Point(BottomRight.X + TextWidth * 3 {EndToken.TokenLen}, BottomRight.Y + Options.Matchs.EnableBlockMatchLineWidth);
      if (BottomRight.X >= GutterWidth - 5) then EditControl.Canvas.FillRect(Rect(BottomRight, TempPoint));
    end;

    if Options.Matchs.BlockMatchLineStyle in [2, 3, 4] then
    begin
      case ColorLayer of
        1: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground1;
        2: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground2;
        3: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground3;
        4: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground4;
        5: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground5;
        6: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground6;
        0: EditControl.Canvas.Brush.Color := Options.Matchs.BlockBackground7;
      end;
      case ColorLayer of
        1: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground1;
        2: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground2;
        3: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground3;
        4: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground4;
        5: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground5;
        6: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground6;
        0: EditControl.Canvas.Font.Color := Options.Matchs.BlockForeground7;
      end;

      EditControl.Canvas.Font.Style := [];
      if Options.Matchs.BlockMatchBold then
        EditControl.Canvas.Font.Style := EditControl.Canvas.Font.Style + [fsBold];
      if Options.Matchs.BlockMatchItalic then
        EditControl.Canvas.Font.Style := EditControl.Canvas.Font.Style + [fsItalic];

      //  StartToken. EndToken
      TopLeft.X := GutterWidth + TextWidth * (StartToken.ColNumber + 1 - LeftColumn);
      TopLeft.Y := TextHeight * (StartToken.LineNumber + 1 - TopRow);

      BottomRight.X := TopLeft.X + TextWidth * StartToken.TokenLen;
      BottomRight.Y := TopLeft.Y + TextHeight;
      if (TopLeft.X >= GutterWidth) and (TopLeft.Y > 0) then
        EditControl.Canvas.TextOut(TopLeft.X, TopLeft.Y, StartToken.Token);

      TopLeft.X := GutterWidth + TextWidth * (EndToken.ColNumber + 1 - LeftColumn);
      TopLeft.Y := TextHeight * (EndToken.LineNumber + 1 - TopRow);

      BottomRight.X := TopLeft.X + TextWidth * EndToken.TokenLen;
      BottomRight.Y := TopLeft.Y + TextHeight;
      if (TopLeft.X >= GutterWidth) and (TopLeft.Y > 0) then
        EditControl.Canvas.TextOut(TopLeft.X, TopLeft.Y, EndToken.Token);
    end;
  end;
begin
  Count := List.Count;
  Stack := TObjectStack.Create;

  i := 1;
  //  Push First Token
  Stack.Push(List.Items[0]);
  while i < Count do
  begin
    if Stack.Count > 0 then
      AheadToken := TPasToken(Stack.Peek)
    else
      AheadToken := nil;
    TempToken := TPasToken(List.Items[i]);

    if not Assigned(AheadToken) then
    begin
      Stack.Push(TempToken);
    end
    else if (TempToken.ItemLayer = AheadToken.ItemLayer) then
    begin
      //  try-finally, try-except
      _DrawTokenMatch(AheadToken, TempToken);
      if (TempToken.TokenID = ptEnd) or (TempToken.TokenID = ptUntil)
        or (TempToken.TokenID = ptThen) or (TempToken.TokenID = ptDo) then Stack.Pop;
    end
    else
      Stack.Push(TempToken);

    Inc(i);
  end;
  FreeAndNil(Stack);
end;

procedure TfrmOptions.TimerCountTimer(Sender: TObject);
var
  EditView: IOTAEditView;
  EditBuffer: IOTAEditBuffer;
begin
  if Options.Matchs.BlockMatchUseHotkey then Exit;

  if Assigned(Options) and ((Now - NowTime) * 86400000 >= Options.Matchs.EnableBlockMatchDelay) then
  begin
    try
      if Assigned(EditControl) then
      begin
        _SaveColor(EditControl);
        try
          EditView := OTAGetCurrentEditView;
          EditBuffer := OTAGetCurrentEditBuffer;
          if Assigned(EditView) and Assigned(EditBuffer) then
            Self.DelphiEditPaintBlockMatch(EditView, EditBuffer);
        finally
          EditView := nil;
          EditBuffer := nil;
          _RestoreColor(EditControl);
        end;
      end;
    except
      ;
    end;
    NowTime := Now();
  end;
end;

procedure TfrmOptions.DelphiEditPaintBookmark(EditView: IOTAEditView; EditBuffer: IOTAEditBuffer);
var
  i, Count: Integer;
  bookmark: TDgBookmark;
  TopLeft, BottomRight: TPoint;
begin
  if FOnTemplateAction then Exit;
  Count := FBookmarks.Count;
  for i := 1 to Count do
  begin
    bookmark := TDgBookmark(Bookmarks.Pop);
    if (bookmark.Line <= BottomRow) and (bookmark.Line >= TopRow) and
      (bookmark.Col <= RightColumn) and (bookmark.Col >= LeftColumn) then
    begin
      EditControl.Canvas.Brush.Color := Options.GutterS.BookmarkBackground;
      EditControl.Canvas.Font.Color := Options.Gutters.BookmarkForeground;
      //Debug('Bookmark[%d, %d]', [bookmark.Line, bookmark.Col]);

      TopLeft.X := GutterWidth + (bookmark.Col - LeftColumn - 1) * TextWidth - 1;
      TopLeft.Y := (bookmark.Line - TopRow) * TextHeight - 1;
      BottomRight.X := TopLeft.X + TextWidth + 2;
      BottomRight.Y := TopLeft.Y + TextHeight + 1;

      EditControl.Canvas.DrawFocusRect(Rect(TopLeft, BottomRight));
      EditControl.Canvas.TextOut(TopLeft.X + 1, TopLeft.Y + 1, IntToStr(i));
    end;
    Bookmarks.Push(bookmark);
  end;
end;

procedure TfrmOptions.DelphiEditPaintBracketMatch(EditView: IOTAEditView; EditBuffer: IOTAEditBuffer);
var
  FTokenPos, FTokenMatchPos: TOTAEditPos;
  FTokenStr, FTokenMatchStr: string;
  TopLeft, BottomRight: TPoint;
begin
  if FOnTemplateAction then Exit;
  if not Options.Matchs.Enabled then Exit;
  if not Options.Matchs.EnableBracketMatch then Exit;
  if not Assigned(EditControl) then Exit;

  if Options.Matchs.BlockMatchCurrentLine then
  try
    GetBracketMatch2(EditView, EditBuffer, EditControl, FTokenPos,
      FTokenMatchPos, FTokenStr, FTokenMatchStr);
  except
    FTokenMatchPos.Col := 0;
  end
  else
  try
    GetBracketMatch(EditView, EditBuffer, EditControl, FTokenPos,
      FTokenMatchPos, FTokenStr, FTokenMatchStr);
  except
    FTokenMatchPos.Col := 0;
  end;

  if (FTokenMatchPos.Col > 0) then
  begin
    EditControl.Canvas.Brush.Color := Options.Matchs.BracketMatchBackground;
    EditControl.Canvas.Font.Color := Options.Matchs.BracketMatchForeground;
    if Options.Matchs.BracketMatchBold then EditControl.Canvas.Font.Style := [fsBold];

    TopLeft.X := GutterWidth + (FTokenPos.Col - EditView.LeftColumn) * TextWidth;
    TopLeft.Y := (FTokenPos.Line - EditView.TopRow) * TextHeight;
    BottomRight.X := TopLeft.X + TextWidth;
    BottomRight.Y := TopLeft.Y + TextHeight;

    // EditControl.Canvas.FillRect(Rect(TopLeft, BottomRight));
    EditControl.Canvas.TextOut(TopLeft.X, TopLeft.Y, FTokenStr);

    if (FTokenMatchPos.Line >= EditView.TopRow) and (FTokenMatchPos.Line <= EditView.BottomRow) and
      (FTokenMatchPos.Col >= EditView.LeftColumn) and (FTokenMatchPos.Col <= EditView.RightColumn) then
    begin
      TopLeft.X := GutterWidth + (FTokenMatchPos.Col - EditView.LeftColumn) * TextWidth;
      TopLeft.Y := (FTokenMatchPos.Line - EditView.TopRow) * TextHeight;
      BottomRight.X := TopLeft.X + TextWidth;
      BottomRight.Y := TopLeft.Y + TextHeight;

      // EditControl.Canvas.FillRect(Rect(TopLeft, BottomRight));
      EditControl.Canvas.TextOut(TopLeft.X, TopLeft.Y, FTokenMatchStr);
    end;
  end;
end;

procedure TfrmOptions.DelphiEditPaintGutter;
var
  i, mStart, mClose, y, CurrentRow: Integer;
  Error: TDgError;
begin
  if not Assigned(FEnhanceGutter) then Exit;
  if FOnTemplateAction then Exit;
  if Assigned(SourceParser.MethodStartToken) and Assigned(SourceParser.MethodCloseToken) then
  begin
    mStart := SourceParser.MethodStartToken.LineNumber + 1;
    mClose := SourceParser.MethodCloseToken.LineNumber + 1;
  end
  else
  begin
    mStart := 0;
    mClose := 0;
  end;

  if (Assigned(FEnhanceGutter)) and Options.Gutters.Enabled then
  begin
    FEnhanceGutter.Refresh;

    CurrentRow := CursorPos.Line;
    FEnhanceGutter.PaintBox.Canvas.Font.Style := [];
    FEnhanceGutter.PaintBox.Canvas.Font.Color := Options.Gutters.LineNumberFontDefaultColor;
    if Options.GutterS.LineNumber then
    begin
      //  Draw Line Number
      for i := TopRow to BottomRow - 1 do
      begin
        y := (i - TopRow) * TextHeight;

        if (mClose > 0) and (i > mStart) then
          FEnhanceGutter.PaintBox.Canvas.Font.Color := Options.Gutters.LineNumberFontColor;

        if (mClose > 0) and (i > mClose) then
          FEnhanceGutter.PaintBox.Canvas.Font.Color := Options.Gutters.LineNumberFontDefaultColor;

        if (i = mStart) or (i = mClose) then
          FEnhanceGutter.PaintBox.Canvas.Font.Color := clRed;
        if (i <> CurrentRow) or (not Options.Gutters.CurrentLineImage) then
          FEnhanceGutter.PaintBox.Canvas.TextOut(1, y, IntToStr(i) + '        ');
      end;
      FEnhanceGutter.PaintBox.Canvas.Font.Color := Options.Gutters.LineNumberFontDefaultColor;

      if (CurrentRow >= TopRow) and (CurrentRow < BottomRow) and Options.GutterS.CurrentLineImage then
      begin
        y := (CurrentRow - TopRow) * TextHeight;
        FEnhanceGutter.PaintBox.Canvas.TextOut(1, y, '             ');
        FEnhanceGutter.PaintBox.Canvas.Draw(2, y, imgCurrentLine.Picture.Graphic)
      end;

      for i := 0 to Errors.Count - 1 do
      begin
        Error := TDgError(Errors.Items[i]);
        if Error.LocalError and (Error.LineNumber >= TopRow) and (Error.LineNumber < BottomRow) then
        begin
          y := (Error.LineNumber - TopRow) * TextHeight;
          FEnhanceGutter.PaintBox.Canvas.TextOut(1, y, '             ');
          if Error.IsWarning and Options.Gutters.QuestionImage then
            FEnhanceGutter.PaintBox.Canvas.Draw(2, y, imgQuestion.Picture.Graphic)
          else if Error.IsError and Options.Gutters.ErrorImage then
            FEnhanceGutter.PaintBox.Canvas.Draw(2, y, imgError.Picture.Graphic)
          else if Options.Gutters.KeyImage then
            FEnhanceGutter.PaintBox.Canvas.Draw(2, y, imgKeyword.Picture.Graphic);
        end;
      end;
    end
    else
      FEnhanceGutter.PaintBox.Refresh;
  end;
end;

procedure TfrmOptions.DelphiEditPaintEx;
var
  EditView: IOTAEditView;
  EditBuffer: IOTAEditBuffer;
begin
  if FOnTemplateAction then Exit;

  FOnDelphiRepaint := True;
  if Assigned(EditControl) then
  begin
    _SaveColor(EditControl);
    EditView := OTAGetCurrentEditView;
    EditBuffer := OTAGetCurrentEditBuffer;

    try
      if Assigned(EditView) and Assigned(EditBuffer) then
      begin
        //Debug('Canvas.Font.Name', EditControl.Canvas.Font.Name);
        //Debug('Canvas.Font.Size', EditControl.Canvas.Font.Size);
        //Debug('Font.Name', EditControl.Font.Name);
        //Debug('Font.Size', EditControl.Font.Size);
        EditControl.Font := EditControl.Canvas.Font;
        //EditControl.Canvas.Font := EditControl.Font;

        GutterWidth := EditBuffer.BufferOptions.LeftGutterWidth;
        TopRow := EditView.TopRow;
        BottomRow := EditView.BottomRow;
        LeftColumn := EditView.LeftColumn;
        RightColumn := EditView.RightColumn;

        //  TODO: Actual TextWidth and TextHeight value ...
        TextWidth := EditControl.Canvas.TextWidth('S');
        TextHeight := EditControl.Canvas.TextHeight('S') + 1;

        try
          DelphiEditPaintBookmark(EditView, EditBuffer);
        except
        end;
        _RestoreColor(EditControl);

        try
          DelphiEditPaintBracketMatch(EditView, EditBuffer);
        except
        end;
        _RestoreColor(EditControl);

        try
          DelphiEditPaintGutter;
        except
        end;
        _RestoreColor(EditControl);

        if not Options.Matchs.BlockMatchUseHotkey then
        begin
          NowTime := Now;
          if Options.Matchs.EnableBlockMatchDelay > 0 then
            TimerCount.Enabled := True
          else
          begin
            TimerCount.Enabled := False;
            try
              DelphiEditPaintBlockMatch(EditView, EditBuffer);
            except
            end;
            _RestoreColor(EditControl);
          end;
        end;
        EditView.Paint;
      end;
    finally
      EditView := nil;
      EditBuffer := nil;
    end;
  end;
  FOnDelphiRepaint := False;
end;

procedure TfrmOptions.WMGetMinMaxInfo(var WindowMsg: TMessage);
type
  PP = ^TP;
  TP = array[0..4] of TPoint;
begin
  PP(WindowMsg.LParam)^[3].X := MINIMUM_WIDTH;
  PP(WindowMsg.LParam)^[3].Y := MINIMUM_HEIGHT;
end;

////////////////////////////////////////////////////////////////////////////////
{ TfrmOptions Properties }

function TfrmOptions.GetCursorPos: TOTAEditPos;
begin
  Result.Col := 0;
  Result.Line := 0;
  try
    Result := OTAGetCursorPos();
  except
  end;
end;

function TfrmOptions.GetEditControl: TDgCustomControl;
begin
  Result := nil;
  if Assigned(FEditControl) and isDelphiEditControl(FEditControl.Handle) then
    Result := FEditControl
  else
  try
    FEditControl := TDgCustomControl(GetDelphiEditControl);
    if Assigned(FEditControl) and isDelphiEditControl(FEditControl.Handle) then
      Result := FEditControl;
  except
  end;
end;

procedure TfrmOptions.SetCursorPos(const Value: TOTAEditPos);
begin
  try
    OTASetCursorPos(Value);
  except
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TfrmOptions Form Event }

procedure TfrmOptions.FormDestroy(Sender: TObject);
begin
  StopCallback;
  TimerCount.Enabled := False;
  if Assigned(FHintWindow) then FHintWindow.ReleaseHandle;
  FreeAndNil(FHintWindow);

  try
    SyntaxThread.Terminate;
    Windows.TerminateThread(SyntaxThread.ThreadID, 0);
  except
  end;
  FreeAndNil(SyntaxThread);

  while FBookmarks.Count > 0 do
    FBookmarks.Pop.Free;
  FreeAndNil(FBookmarks);

  Errors := DGUtils.FreeObjectList(Errors);
  FreeAndNil(FGutterPreview2);
  FreeAndNil(FGutterPreview1);
  FreeAndNil(FTokenMatchPreview);
  FreeAndNil(Options);
end;

procedure TfrmOptions.FormCreate(Sender: TObject);
begin
  Options := TDgOptions.Create;
  DGUtils.LoadDGExpertOptions(Options);

  btnParseDelphiTemplatesClick(nil);

  FBookmarks := TObjectQueue.Create;
  FEditWndProc := nil;
  FPrevEditWndProc := nil;

  FTokenMatchPreview := TBitmap.Create;
  LoadBitmapFromRes('TokenMatch', FTokenMatchPreview);
  pbMatchPreview.Canvas.Draw(0, 0, FTokenMatchPreview);

  FGutterPreview1 := TBitmap.Create;
  DGUtils.LoadBitmapFromRes('Bookmark', FGutterPreview1);
  imgBookmark.Canvas.Draw(0, 0, FGutterPreview1);
  DGUtils.LoadBitmapFromRes('Question', FGutterPreview1);
  imgQuestion.Canvas.Draw(0, 0, FGutterPreview1);
  DGUtils.LoadBitmapFromRes('Keyword', FGutterPreview1);
  imgKeyword.Canvas.Draw(0, 0, FGutterPreview1);
  DGUtils.LoadBitmapFromRes('Error', FGutterPreview1);
  imgError.Canvas.Draw(0, 0, FGutterPreview1);
  DGUtils.LoadBitmapFromRes('CurrentLine', FGutterPreview1);
  imgCurrentLine.Canvas.Draw(0, 0, FGutterPreview1);
  DGUtils.LoadBitmapFromRes('GutterPreview', FGutterPreview1);

  FGutterPreview2 := TBitmap.Create;
  FGutterPreview2.Assign(FGutterPreview1);
  FGutterPreview2.Canvas.MoveTo(152, 83);
  FGutterPreview2.Canvas.LineTo(152, 97);
  imgGutterPreview.Canvas.Draw(0, 0, FGutterPreview1);

  SyntaxThread := TDGCompiler.Create(True);
  SyntaxThread.FreeOnTerminate := False;
  SyntaxThread.Priority := tpIdle;
  try
    if Options.Syntaxs.Enabled and (not SyntaxThread.Suspended) then SyntaxThread.Resume;
  except
    ;
  end;
end;

procedure TfrmOptions.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.HintPause := SaveHintPause;
  Application.HintHidePause := SaveHintHidePause;
  try
    if Options.Syntaxs.Enabled and SyntaxThread.Suspended then SyntaxThread.Resume;
  except
    ;
  end;
  Action := caHide;
end;

procedure TfrmOptions.FormShow(Sender: TObject);
begin
  try
    if (not SyntaxThread.Suspended) then SyntaxThread.Suspend;
  except
  end;

  SaveHintPause := Application.HintPause;
  SaveHintHidePause := Application.HintHidePause;
  Application.HintPause := 0;
  Application.HintHidePause := 10000;

  with Options do
  begin
    cbEnableCodeTemplate.Checked := Templates.Enabled;
    btnParseDelphiTemplatesClick(nil);

    cbEnableEnhanceGutter.Checked := Gutters.Enabled;
    GutterWidthUpDown.Position := Gutters.GutterWidth;
    cbAutoReInstallGutter.Checked := Gutters.AutoReInstall;
    cbShowLineNumber.Checked := Gutters.LineNumber;
    cbShowCurrentLineImage.Checked := Gutters.CurrentLineImage;
    cbShowBookmark.Checked := Gutters.BookmarkImage;
    cbShowKeyword.Checked := Gutters.KeyImage;
    cbShowError.Checked := Gutters.ErrorImage;
    cbShowQuestion.Checked := Gutters.QuestionImage;
    paneBookmark.Color := Gutters.BookmarkBackground;
    paneBookmark.Font.Color := Gutters.BookmarkForeground;
    pbGutterPreview.Font.Name := Gutters.LineNumberFontName;
    pbGutterPreview.Font.Size := Gutters.LineNumberFontSize;
    pbGutterPreview.Font.Color := Gutters.LineNumberFontColor;
    paneLineNumberDefault.Color := Gutters.LineNumberFontDefaultColor;

    cbEnableTokenMatch.Checked := Matchs.Enabled;
    cbEnableBlockMatch.Checked := Matchs.EnableBlockMatch;
    BlockMatchLineWidthUpDown.Position := Matchs.EnableBlockMatchLineWidth;
    cbBlockMatchStyle.ItemIndex := Matchs.BlockMatchLineStyle;
    BlockMatchDelayUpDown.Position := Matchs.EnableBlockMatchDelay;

    cbBlockMatchBold.Checked := Matchs.BlockMatchBold;
    cbBlockMatchItalic.Checked := Matchs.BlockMatchItalic;
    cbBlockMatchUseHotkey.Checked := Matchs.BlockMatchUseHotkey;
    cbBracketMatchCurrentLine.Checked := Matchs.BlockMatchCurrentLine;

    paneBlock1.Color := Matchs.BlockBackground1;
    paneBlock2.Color := Matchs.BlockBackground2;
    paneBlock3.Color := Matchs.BlockBackground3;
    paneBlock4.Color := Matchs.BlockBackground4;
    paneBlock5.Color := Matchs.BlockBackground5;
    paneBlock6.Color := Matchs.BlockBackground6;
    paneBlock7.Color := Matchs.BlockBackground7;

    paneBlock1.Font.Color := Matchs.BlockForeground1;
    paneBlock2.Font.Color := Matchs.BlockForeground2;
    paneBlock3.Font.Color := Matchs.BlockForeground3;
    paneBlock4.Font.Color := Matchs.BlockForeground4;
    paneBlock5.Font.Color := Matchs.BlockForeground5;
    paneBlock6.Font.Color := Matchs.BlockForeground6;
    paneBlock7.Font.Color := Matchs.BlockForeground7;

    cbEnableBracketMatch.Checked := Matchs.EnableBracketMatch;
    paneBracketMatch.Font.Color := Matchs.BracketMatchForeground;
    paneBracketMatch.Color := Matchs.BracketMatchBackground;
    cbBracketMatchBold.Checked := Matchs.BracketMatchBold;

    cbSyntaxError.Checked := Syntaxs.Enabled;
    SyntaxIntervalUpDown.Position := Syntaxs.Interval;
    edtCompileBin.Text := Syntaxs.CompileBin;
    edtTempDir.Text := Syntaxs.TempDir;

    lbSources.Items.Text := AnsiReplaceText(Syntaxs.IncludesDir, ';', #13#10);
    //lbUnits.Items.Text := AnsiReplaceText(Syntaxs.UnitsDir, ';', #13#10);
    lbUnits.Items.Text := AnsiReplaceText(DGUtils.GetDelphi7LibPath, ';', #13#10);
    edtAddtional.Text := Syntaxs.Addtionals;
  end;

  TimerGutterAnimate.Enabled := PageControl.ActivePage = tsEnhanceGutter;
  AnimateIndex := 1;

  EnableControls(tsTokenMatch, cbEnableTokenMatch.Checked);
  EnableControls(tsEnhanceGutter, cbEnableEnhanceGutter.Checked);
  EnableControls(tsSyntaxError, cbSyntaxError.Checked);

  EnableControls(gbGutterLineNumber, cbShowLineNumber.Checked and cbEnableEnhanceGutter.Checked);
  EnableControls(gbBracketMatch, cbEnableBracketMatch.Checked and cbEnableTokenMatch.Checked);
  EnableControls(gbBlockMatch, cbEnableBlockMatch.Checked and cbEnableTokenMatch.Checked);

  edtBlockMatchDelay.Enabled := (not cbBlockMatchUseHotkey.Checked) and cbEnableTokenMatch.Checked and cbEnableBlockMatch.Checked;
  BlockMatchDelayUpDown.Enabled := (not cbBlockMatchUseHotkey.Checked) and cbEnableTokenMatch.Checked and cbEnableBlockMatch.Checked;

  cbBlockMatchBold.Enabled := (cbBlockMatchStyle.ItemIndex in [2, 3, 4]) and cbEnableTokenMatch.Checked and cbEnableBlockMatch.Checked;
  cbBlockMatchItalic.Enabled := cbBlockMatchBold.Enabled;

  cbEnableTokenMatch.Enabled := True;
  cbEnableCodeTemplate.Enabled := True;
  cbEnableEnhanceGutter.Enabled := True;
  cbSyntaxError.Enabled := True;
end;

procedure TfrmOptions.btnOKSaveClick(Sender: TObject);
begin
  btnApplyClick(Sender);
  Close;
end;

procedure TfrmOptions.btnApplyClick(Sender: TObject);
begin
  with Options do
  begin
    Templates.Enabled := cbEnableCodeTemplate.Checked;

    Gutters.Enabled := cbEnableEnhanceGutter.Checked;
    Gutters.GutterWidth := GutterWidthUpDown.Position;
    Gutters.AutoReInstall := cbAutoReInstallGutter.Checked;
    Gutters.LineNumber := cbShowLineNumber.Checked;
    Gutters.CurrentLineImage := cbShowCurrentLineImage.Checked;
    Gutters.BookmarkImage := cbShowBookmark.Checked;
    Gutters.KeyImage := cbShowKeyword.Checked;
    Gutters.ErrorImage := cbShowError.Checked;
    Gutters.QuestionImage := cbShowQuestion.Checked;
    Gutters.BookmarkBackground := paneBookmark.Color;
    Gutters.BookmarkForeground := paneBookmark.Font.Color;
    Gutters.LineNumberFontName := pbGutterPreview.Font.Name;
    Gutters.LineNumberFontSize := pbGutterPreview.Font.Size;
    Gutters.LineNumberFontColor := pbGutterPreview.Font.Color;
    Gutters.LineNumberFontDefaultColor := paneLineNumberDefault.Color;

    Matchs.Enabled := cbEnableTokenMatch.Checked;
    Matchs.EnableBlockMatch := cbEnableBlockMatch.Checked;
    Matchs.EnableBlockMatchLineWidth := BlockMatchLineWidthUpDown.Position;
    Matchs.BlockMatchLineStyle := cbBlockMatchStyle.ItemIndex;
    Matchs.EnableBlockMatchDelay := BlockMatchDelayUpDown.Position;

    Matchs.BlockMatchBold := cbBlockMatchBold.Checked;
    Matchs.BlockMatchItalic := cbBlockMatchItalic.Checked;
    Matchs.BlockMatchUseHotkey := cbBlockMatchUseHotkey.Checked;
    Matchs.BlockMatchCurrentLine := cbBracketMatchCurrentLine.Checked;

    Matchs.BlockBackground1 := paneBlock1.Color;
    Matchs.BlockBackground2 := paneBlock2.Color;
    Matchs.BlockBackground3 := paneBlock3.Color;
    Matchs.BlockBackground4 := paneBlock4.Color;
    Matchs.BlockBackground5 := paneBlock5.Color;
    Matchs.BlockBackground6 := paneBlock6.Color;
    Matchs.BlockBackground7 := paneBlock7.Color;

    Matchs.BlockForeground1 := paneBlock1.Font.Color;
    Matchs.BlockForeground2 := paneBlock2.Font.Color;
    Matchs.BlockForeground3 := paneBlock3.Font.Color;
    Matchs.BlockForeground4 := paneBlock4.Font.Color;
    Matchs.BlockForeground5 := paneBlock5.Font.Color;
    Matchs.BlockForeground6 := paneBlock6.Font.Color;
    Matchs.BlockForeground7 := paneBlock7.Font.Color;

    Matchs.EnableBracketMatch := cbEnableBracketMatch.Checked;
    Matchs.BracketMatchForeground := paneBracketMatch.Font.Color;
    Matchs.BracketMatchBackground := paneBracketMatch.Color;
    Matchs.BracketMatchBold := cbBracketMatchBold.Checked;

    Syntaxs.Enabled := cbSyntaxError.Checked;
    Syntaxs.Interval := SyntaxIntervalUpDown.Position;
    Syntaxs.CompileBin := edtCompileBin.Text;
    Syntaxs.TempDir := edtTempDir.Text;
    Syntaxs.Addtionals := edtAddtional.Text;
    Syntaxs.IncludesDir := AnsiReplaceText(lbSources.Items.Text, #13#10, ';');
    Syntaxs.UnitsDir := AnsiReplaceText(lbUnits.Items.Text, #13#10, ';');
  end;

  DGUtils.SaveDGExpertOptions(Options);
  if Assigned(EditControl) then
  try
    if not Options.Gutters.Enabled then
      UninstallGutter
    else // if change Font setting would cause mix render.
    begin
      Self.InstallGutter;
      FEnhanceGutter.Width := Options.Gutters.GutterWidth;
      FEnhanceGutter.Refresh;
    end;
    EditControl.Refresh;
    DelphiEditPaintEx;
  except
    ;
  end;
end;

procedure TfrmOptions.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmOptions.cbEnableEnhanceGutterClick(Sender: TObject);
begin
  EnableControls(tsEnhanceGutter, cbEnableEnhanceGutter.Checked);
  cbEnableEnhanceGutter.Enabled := True;
end;

procedure TfrmOptions.cbShowLineNumberClick(Sender: TObject);
begin
  if Sender = cbShowLineNumber then
    EnableControls(gbGutterLineNumber, cbShowLineNumber.Checked);
  Self.pbGutterPreview.Refresh;
end;

procedure TfrmOptions.cbEnableTokenMatchClick(Sender: TObject);
begin
  EnableControls(tsTokenMatch, cbEnableTokenMatch.Checked);
  cbEnableTokenMatch.Enabled := True;
  pbMatchPreview.Refresh;
end;

procedure TfrmOptions.cbEnableBlockMatchClick(Sender: TObject);
begin
  EnableControls(gbBlockMatch, cbEnableBlockMatch.Checked);
  pbMatchPreview.Refresh;
end;

procedure TfrmOptions.cbEnableBracketMatchClick(Sender: TObject);
begin
  EnableControls(gbBracketMatch, cbEnableBracketMatch.Checked);
end;

procedure TfrmOptions.cbBlockMatchUseHotkeyClick(Sender: TObject);
begin
  edtBlockMatchDelay.Enabled := not cbBlockMatchUseHotkey.Checked;
  BlockMatchDelayUpDown.Enabled := not cbBlockMatchUseHotkey.Checked;
end;

procedure TfrmOptions.cbBlockMatchStyleSelect(Sender: TObject);
begin
  cbBlockMatchBold.Enabled := cbBlockMatchStyle.ItemIndex in [2, 3, 4];
  cbBlockMatchItalic.Enabled := cbBlockMatchBold.Enabled;
  Self.pbMatchPreview.Refresh;
end;

procedure TfrmOptions.cbSyntaxErrorClick(Sender: TObject);
begin
  EnableControls(tsSyntaxError, cbSyntaxError.Checked);
  cbSyntaxError.Enabled := True;
end;

procedure TfrmOptions.OnColorPanelClick(Sender: TObject);
begin
  ColorDialog.Color := (Sender as TPanel).Color;
  if ColorDialog.Execute then
  begin
    (Sender as TPanel).Color := ColorDialog.Color;
    pbMatchPreview.Refresh;
  end;
end;

procedure TfrmOptions.OnColorPanelRightClick(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  Handled := True;
  ColorDialog.Color := (Sender as TPanel).Font.Color;
  if ColorDialog.Execute then
  begin
    (Sender as TPanel).Font.Color := ColorDialog.Color;
    pbMatchPreview.Refresh;
  end;
end;

procedure TfrmOptions.PageControlChange(Sender: TObject);
begin
  TimerGutterAnimate.Enabled := PageControl.ActivePage = tsEnhanceGutter;
  AnimateIndex := 1;
end;

procedure TfrmOptions.btnGutterFontClick(Sender: TObject);
begin
  FontDialog.Font := pbGutterPreview.Font;
  if FontDialog.Execute then
  begin
    pbGutterPreview.Font.Name := FontDialog.Font.Name;
    pbGutterPreview.Font.Size := FontDialog.Font.Size;
    pbGutterPreview.Font.Color := FontDialog.Font.Color;
    pbGutterPreview.Refresh;
  end;
end;

procedure TfrmOptions.TimerGutterAnimateTimer(Sender: TObject);
begin
  TimerGutterAnimate.Enabled := PageControl.ActivePage = tsEnhanceGutter;
  if TimerGutterAnimate.Enabled then
  begin
    Inc(AnimateIndex);
    if AnimateIndex > 2 then AnimateIndex := 1;
    case AnimateIndex of
      1: imgGutterPreview.Canvas.Draw(0, 0, FGutterPreview1);
      2: imgGutterPreview.Canvas.Draw(0, 0, FGutterPreview2);
    end;
  end;
end;

procedure TfrmOptions.pbGutterPreviewPaint(Sender: TObject);
var
  i, y: Integer;
  TextHeight: Integer;

  procedure __Draw(y: Integer; img: TImage);
  begin
    pbGutterPreview.Canvas.TextOut(1, y, '             ');
    pbGutterPreview.Canvas.Draw(2, y, img.Picture.Graphic);
  end;

begin
  TextHeight := 16;
  for i := 924 to 934 do
  begin
    y := (i - 924) * TextHeight;
    if cbShowLineNumber.Checked then pbGutterPreview.Canvas.TextOut(1, y, IntToStr(i) + '      ');
    case i of
      926: if cbShowCurrentLineImage.Checked then __Draw(y, imgCurrentLine);
      924: if cbShowBookmark.Checked then __Draw(y, imgBookmark);
      932: if cbShowKeyword.Checked then __Draw(y, imgKeyword);
      930: if cbShowError.Checked then __Draw(y, imgError);
      928: if cbShowQuestion.Checked then __Draw(y, imgQuestion);
    end;
  end;

end;

procedure TfrmOptions.pbMatchPreviewPaint(Sender: TObject);
var
  TL, BR: TPoint;
  Style, LineWidth: Integer;

  procedure __Draw(x1, x2, y1, y2, xx1, yy1, yy2: Integer; Str1, Str2: string);
  begin
    if Style in [2, 3, 4] then
    begin
      pbMatchPreview.Canvas.TextOut(x1, y1, Str1);
      pbMatchPreview.Canvas.TextOut(x2, y2, Str2);
    end;

    if Style in [0, 1, 2, 3] then
    begin
      pbMatchPreview.Canvas.Brush.Color := pbMatchPreview.Canvas.Font.Color;
      TL := Point(xx1, yy1);
      BR := Point(xx1 + LineWidth, yy2);
      pbMatchPreview.Canvas.FillRect(Rect(TL, BR));
    end;
  end;

begin
  // paneBlock1.Color
  pbMatchPreview.Canvas.Draw(0, 0, FTokenMatchPreview);
  LineWidth := BlockMatchLineWidthUpDown.Position;
  Style := cbBlockMatchStyle.ItemIndex;

  if cbEnableBlockMatch.Checked and cbEnableTokenMatch.Checked then
  begin
    with pbMatchPreview.Canvas do
    begin
      Font.Style := [];
      if cbBlockMatchBold.Checked then Font.Style := Font.Style + [fsBold];
      if cbBlockMatchItalic.Checked then Font.Style := Font.Style + [fsItalic];

      Brush.Color := paneBlock1.Color;
      Font.Color := paneBlock1.Font.Color;
      __Draw(23, 23, 1, 288, 22, 16, 291, 'begin', 'end');

      Brush.Color := paneBlock2.Color;
      Font.Color := paneBlock2.Font.Color;
      __Draw(37, 37, 17, 272, 36, 32, 275, 'try', 'end');

      Brush.Color := paneBlock3.Color;
      Font.Color := paneBlock3.Font.Color;
      __Draw(51, 51, 33, 240, 50, 48, 243, 'try', 'end');

      Brush.Color := paneBlock4.Color;
      Font.Color := paneBlock4.Font.Color;
      __Draw(65, 65, 49, 208, 64, 64, 211, 'case', 'end');

      Brush.Color := paneBlock5.Color;
      Font.Color := paneBlock5.Font.Color;
      __Draw(100, 79, 65, 192, 78, 80, 195, 'begin', 'end');

      Brush.Color := paneBlock6.Color;
      Font.Color := paneBlock6.Font.Color;
      __Draw(100, 100, 97, 176, 99, 112, 179, 'begin', 'end');

      Brush.Color := paneBlock7.Color;
      Font.Color := paneBlock7.Font.Color;
      __Draw(114, 114, 129, 160, 113, 144, 163, 'begin', 'end');
    end;
  end;
end;

procedure TfrmOptions.OnSpeedButton1Click(Sender: TObject);
var
  EditView: IOTAEditView;
  NewLine: Integer;
begin
  EditView := OTAGetCurrentEditView;
  try
    if Assigned(EditView) then
    begin
      with TfrmGotoLine.Create(Self) do
      begin
        Edit1.Text := IntToStr(CursorPos.Line);
        if ShowModal = mrOK then
        begin
          try
            NewLine := StrToInt(Edit1.Text);
            if NewLine >= 1 then
            begin
              OTASetCursorPos(StrToInt(Edit1.Text), 1);
              EditView.MoveViewToCursor;
              FEditControl.Refresh;
            end;
          except
            Debug('OnSpeedButton1Click Exception ...');
            Debug();
          end;
        end;
        Free;
      end;
    end;
  finally
    EditView := nil;
  end;
end;

procedure TfrmOptions.OnSpeedButton2Click(Sender: TObject);
begin
  try
    Self.Bookmarks.Push(TDgBookmark.Create(CursorPos.Line, CursorPos.Col));
    FEditControl.Refresh;
  except
    ;
  end;
end;

procedure TfrmOptions.OnEnhanceGutterClick(Sender: TObject);
begin
  DebugEnterMethod('TfrmOptions.OnEnhanceGutterClick');
  try
    try
      if Assigned(FHintWindow) then FHintWindow.ReleaseHandle;
      FreeAndNil(FHintWindow);
    except
      Debug('OnEnhanceGutterClick Exception ...');
      Debug;
    end;

    FEnhanceGutter.Refresh;
    try
      Self.DelphiEditPaintGutter;
    except
      ;
    end;
    OnSpeedButton1Click(Sender);
  finally
    DebugExitMethod();
  end;
end;

procedure TfrmOptions.OnEnhanceGutterMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  LineNumber, i: Integer;
  Error: TDGError;
  aRect: TRect;
  lt, rb: TPoint;
  HintActive: Boolean;
begin
  if not Options.Syntaxs.Enabled then Exit;
  if TextHeight <= 0 then Exit;
  LineNumber := (Y div TextHeight) + TopRow;
  HintActive := False;
  if (X > 0) and (X < Options.Gutters.GutterWidth) and (FSaveHintWindowLine <> LineNumber) then
  begin
    FSaveHintWindowLine := LineNumber;
    Debug('LineNumber', LineNumber);
    for i := 0 to Errors.Count - 1 do
    begin
      Error := TDGError(Errors.Items[i]);
      if Error.LineNumber = LineNumber then
      begin
        try
          if Assigned(FHintWindow) then FHintWindow.ReleaseHandle;
          FreeAndNil(FHintWindow);
        except
          ;
        end;
        FHintWindow := TDGHintWindow.Create(Self);
        lt := Point(Options.Gutters.GutterWidth, (LineNumber - TopRow) * TextHeight);
        rb := Point(lt.X + FHintWindow.Canvas.TextWidth(Error.ErrorMsg), lt.Y + 18);
        aRect := Rect(lt, rb);
        Windows.ClientToScreen(FEnhanceGutter.Handle, aRect.TopLeft);
        Windows.ClientToScreen(FEnhanceGutter.Handle, aRect.BottomRight);
        FHintWindow.ActivateHint(aRect, Error.ErrorMsg);
        HintActive := True;
      end;

      if not HintActive then
      try
        if Assigned(FHintWindow) then FHintWindow.ReleaseHandle;
        FreeAndNil(FHintWindow);
      except
        ;
      end;
    end;
  end;
end;

procedure TfrmOptions.btnAddSourceClick(Sender: TObject);
var
  Folder: string;
begin
  if GetFolder(Handle, 'Select Compile Source and Resource Path ...', Folder) then
  begin
    Folder := '"' + Folder + '"';
    if lbSources.Items.IndexOf(Folder) < 0 then lbSources.Items.Add(Folder);
  end;
end;

procedure TfrmOptions.btnDelSourceClick(Sender: TObject);
begin
  lbSources.DeleteSelected;
end;

procedure TfrmOptions.btnAddUnitClick(Sender: TObject);
var
  Folder: string;
begin
  if GetFolder(Handle, 'Select Compile Unit and Package Path ...', Folder) then
  begin
    Folder := '"' + Folder + '"';
    if lbUnits.Items.IndexOf(Folder) < 0 then lbUnits.Items.Add(Folder);
  end;
end;

procedure TfrmOptions.btnDelUnitClick(Sender: TObject);
begin
  lbUnits.DeleteSelected;
end;

procedure TfrmOptions.btnSelCompileBinClick(Sender: TObject);
begin
  if DlgSyntaxError.Execute then edtCompileBin.Text := DlgSyntaxError.FileName;
end;

procedure TfrmOptions.btnSelTempDirClick(Sender: TObject);
var
  Folder: string;
begin
  if GetFolder(Handle, 'Select Temp Work Dir ...', Folder) then edtTempDir.Text := Folder;
end;

procedure TfrmOptions.btnParseDelphiTemplatesClick(Sender: TObject);
var
  i: Integer;
  TemplateObj: TDgTemplate;
begin
  Options.Templates.GetTemplates;
  lbTemplateKeywords.Clear;
  for i := 0 to Options.Templates.TemplateObjects.Count - 1 do
  begin
    TemplateObj := Options.Templates.TemplateObjects.Items[i] as TDgTemplate;
    lbTemplateKeywords.Items.Add(TemplateObj.Keyword);
  end;

  if lbTemplateKeywords.Items.Count > 0 then
  begin
    lbTemplateKeywords.ItemIndex := 0;
    lbTemplateKeywordsClick(nil);
  end;
end;

procedure TfrmOptions.lbTemplateKeywordsClick(Sender: TObject);
var
  TemplateObj: TDgTemplate;
begin
  if lbTemplateKeywords.ItemIndex >= 0 then
  begin
    // lbTemplateKeywords.ItemIndex
    TemplateObj := Options.Templates.TemplateObjects.Items[lbTemplateKeywords.ItemIndex] as TDgTemplate;
    edtTemplateDescription.Text := TemplateObj.Description;
    memoTemplateContent.Lines.Text := TemplateObj.Content.Text;
  end;
end;

procedure TfrmOptions.lbTemplateKeywordsKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  lbTemplateKeywordsClick(nil);
end;

procedure TfrmOptions.btnLaunchDelphiTemplateEditorClick(Sender: TObject);
var
  NTAServices: INTAServices;
begin
  // 81 "Action Editor Options... "
  NTAServices := (BorlandIDEServices as INTAServices);
  try
    TimerFindEdtPropWnd.Enabled := true;
    try
      if Assigned(NTAServices) then NTAServices.ActionList.Actions[81].Execute;
      btnParseDelphiTemplatesClick(nil);
    finally
      TimerFindEdtPropWnd.Enabled := false;
    end;
  finally
    NTAServices := nil;
  end;
end;

procedure TfrmOptions.TimerFindEdtPropWndTimer(Sender: TObject);
var
  EdtPropWnd: HWND;
  EdtPropDlg: TWinControl;
  PropSheetPanel: TPanel;
  PropSheet: TPageControl;
  gbEdtPropOptions: TGroupBox;
  btnEdtiCodeTemplate: TButton;
  i, j, k: integer;
begin
  EdtPropWnd := 0;
  btnEdtiCodeTemplate := nil;
  while (EdtPropWnd < 32) and TimerFindEdtPropWnd.Enabled do
  begin
    EdtPropWnd := FindWindow('TPasEditorPropertyDialog', nil);
    Application.ProcessMessages;
  end;

  if TimerFindEdtPropWnd.Enabled then
  begin
    TimerFindEdtPropWnd.Enabled := False;
    for i := 0 to Application.ComponentCount - 1 do
    begin
      try
        //  Debug(Application.Components[i].ClassName);
        if Application.Components[i].ClassName = 'TPasEditorPropertyDialog' then
        begin
          EdtPropDlg := Application.Components[i] as TWinControl;
          Debug('<<< Find TPasEditorPropertyDialog', EdtPropDlg);

          PropSheetPanel := EdtPropDlg.Controls[1] as TPanel;
          Debug('<<<<< Find Container Panel', PropSheetPanel);

          PropSheet := PropSheetPanel.Controls[0] as TPageControl;
          Debug('<<<<< Find TPageControl', PropSheet);

          //  Set Active Page Index
          PropSheet.ActivePageIndex := 1;
          for j := 0 to PropSheet.ActivePage.ControlCount - 1 do
          begin
            if (PropSheet.ActivePage.Controls[j] is TGroupBox) then
            begin
              gbEdtPropOptions := PropSheet.ActivePage.Controls[j] as TGroupBox;
              Debug('<<<<<<< Find GroupBox', gbEdtPropOptions);
              for k := 0 to gbEdtPropOptions.ControlCount - 1 do
              begin
                if gbEdtPropOptions.Controls[k] is TButton then
                begin
                  btnEdtiCodeTemplate := gbEdtPropOptions.Controls[k] as TButton;
                  Debug('<<<<<<<<< Find Button', btnEdtiCodeTemplate);
                  DebugAddSeparator;
                  break;
                end;
              end;
              break;
            end;
          end;
          break;
        end;
      except
        ;
      end;
    end;
  end;

  if Assigned(btnEdtiCodeTemplate) then btnEdtiCodeTemplate.Click;
end;

end.

