unit DGTypes;

interface

uses
  Windows, Messages, Forms, SysUtils, Graphics, Classes, Controls, Contnrs,
  mwSimplePasPar, mwPasLexTypes, mwPasLex, ToolsAPI, ExtCtrls, ComCtrls,
  StdCtrls, Buttons, ComObj;

{$I DGExperts.Inc}

type
  TDgCodeInsightType = (dcitNone, dcitVar, dcitConstant, dcitType, dcitFunction, dcitProcedure);

type
  TDgCodeTemplateOptions = class(TPersistent)
  private
    FEnable: Boolean;
    FTemplateObjects: TObjectList;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetTemplates();
    function GetTemplateContentFromKey(const TemplateKey: string): string;
  published
    property Enabled: Boolean read FEnable write FEnable;
    property TemplateObjects: TObjectList read FTemplateObjects;
  end;

  TDgGutterOptions = class(TPersistent)
  private
    FAutoReInstall: Boolean;
    FBookmarkBackground: TColor;
    FBookmarkForeground: TColor;
    FBookmarkImage: Boolean;
    FCurrentLineImage: Boolean;
    FEnabled: Boolean;
    FErrorImage: Boolean;
    FKeyImage: Boolean;
    FLineNumber: Boolean;
    FLineNumberFontColor: TColor;
    FLineNumberFontName: TFontName;
    FLineNumberFontSize: Integer;
    FQuestionImage: Boolean;
    FLineNumberFontDefaultColor: TColor;
    FGutterWidth: Integer;
  published
    property Enabled: Boolean read FEnabled write FEnabled;
    property GutterWidth: Integer read FGutterWidth write FGutterWidth;
    property AutoReInstall: Boolean read FAutoReInstall write FAutoReInstall;
    property LineNumber: Boolean read FLineNumber write FLineNumber;
    property CurrentLineImage: Boolean read FCurrentLineImage write FCurrentLineImage;
    property LineNumberFontName: TFontName read FLineNumberFontName write FLineNumberFontName;
    property LineNumberFontSize: Integer read FLineNumberFontSize write FLineNumberFontSize;
    property LineNumberFontColor: TColor read FLineNumberFontColor write FLineNumberFontColor;
    property LineNumberFontDefaultColor: TColor read FLineNumberFontDefaultColor write FLineNumberFontDefaultColor;
    property BookmarkImage: Boolean read FBookmarkImage write FBookmarkImage;
    property KeyImage: Boolean read FKeyImage write FKeyImage;
    property ErrorImage: Boolean read FErrorImage write FErrorImage;
    property QuestionImage: Boolean read FQuestionImage write FQuestionImage;
    property BookmarkBackground: TColor read FBookmarkBackground write FBookmarkBackground;
    property BookmarkForeground: TColor read FBookmarkForeground write FBookmarkForeground;
  end;

  TDgTokenMatchOptions = class(TPersistent)
  private
    FBlockBackground1: TColor;
    FBlockBackground2: TColor;
    FBlockBackground3: TColor;
    FBlockBackground4: TColor;
    FBlockBackground5: TColor;
    FBlockBackground6: TColor;
    FBlockBackground7: TColor;
    FBlockForeground1: TColor;
    FBlockForeground2: TColor;
    FBlockForeground3: TColor;
    FBlockForeground4: TColor;
    FBlockForeground5: TColor;
    FBlockForeground6: TColor;
    FBlockForeground7: TColor;
    FBlockMatchLineStyle: Integer;
    FBracketMatchBackground: TColor;
    FBracketMatchBold: Boolean;
    FBracketMatchForeground: TColor;
    FEnableBlockMatch: Boolean;
    FEnableBlockMatchLineWidth: Integer;
    FEnableBracketMatch: Boolean;
    FEnabled: Boolean;
    FBlockMatchBold: Boolean;
    FBlockMatchItalic: Boolean;
    FEnableBlockMatchDelay: Integer;
    FBlockMatchUseHotkey: Boolean;
    FBlockMatchCurrentLine: Boolean;
  published
    property BlockBackground1: TColor read FBlockBackground1 write FBlockBackground1;
    property BlockBackground2: TColor read FBlockBackground2 write FBlockBackground2;
    property BlockBackground3: TColor read FBlockBackground3 write FBlockBackground3;
    property BlockBackground4: TColor read FBlockBackground4 write FBlockBackground4;
    property BlockBackground5: TColor read FBlockBackground5 write FBlockBackground5;
    property BlockBackground6: TColor read FBlockBackground6 write FBlockBackground6;
    property BlockBackground7: TColor read FBlockBackground7 write FBlockBackground7;
    property BlockForeground1: TColor read FBlockForeground1 write FBlockForeground1;
    property BlockForeground2: TColor read FBlockForeground2 write FBlockForeground2;
    property BlockForeground3: TColor read FBlockForeground3 write FBlockForeground3;
    property BlockForeground4: TColor read FBlockForeground4 write FBlockForeground4;
    property BlockForeground5: TColor read FBlockForeground5 write FBlockForeground5;
    property BlockForeground6: TColor read FBlockForeground6 write FBlockForeground6;
    property BlockForeground7: TColor read FBlockForeground7 write FBlockForeground7;
    property BlockMatchUseHotkey: Boolean read FBlockMatchUseHotkey write FBlockMatchUseHotkey;
    property BlockMatchCurrentLine: Boolean read FBlockMatchCurrentLine write FBlockMatchCurrentLine;
    property BlockMatchBold: Boolean read FBlockMatchBold write FBlockMatchBold;
    property BlockMatchItalic: Boolean read FBlockMatchItalic write FBlockMatchItalic;
    property BlockMatchLineStyle: Integer read FBlockMatchLineStyle write FBlockMatchLineStyle;
    property BracketMatchBackground: TColor read FBracketMatchBackground write FBracketMatchBackground;
    property BracketMatchBold: Boolean read FBracketMatchBold write FBracketMatchBold;
    property BracketMatchForeground: TColor read FBracketMatchForeground write FBracketMatchForeground;
    property EnableBlockMatch: Boolean read FEnableBlockMatch write FEnableBlockMatch;
    property EnableBlockMatchDelay: Integer read FEnableBlockMatchDelay write FEnableBlockMatchDelay;
    property EnableBlockMatchLineWidth: Integer read FEnableBlockMatchLineWidth write FEnableBlockMatchLineWidth;
    property EnableBracketMatch: Boolean read FEnableBracketMatch write FEnableBracketMatch;
    property Enabled: Boolean read FEnabled write FEnabled;
  end;

  TDgSyntaxErrorOptions = class(TPersistent)
  private
    FAddtionals: string;
    FUnitsDir: string;
    FTempDir: string;
    FIncludesDir: string;
    FCompileBin: string;
    FInterval: Integer;
    FEnabled: Boolean;
  published
    property CompileBin: string read FCompileBin write FCompileBin;
    property TempDir: string read FTempDir write FTempDir;
    property IncludesDir: string read FIncludesDir write FIncludesDir;
    property UnitsDir: string read FUnitsDir write FUnitsDir;
    property Addtionals: string read FAddtionals write FAddtionals;
    property Interval: Integer read FInterval write FInterval;
    property Enabled: Boolean read FEnabled write FEnabled;
  end;

  TDgOptions = class(TPersistent)
  public
    Templates: TDgCodeTemplateOptions;
    Gutters: TDgGutterOptions;
    Matchs: TDgTokenMatchOptions;
    Syntaxs: TDgSyntaxErrorOptions;
    constructor Create;
    destructor Destroy; override;
  end;

  TOTAEditPosArray = array of TOTAEditPos;

  TDgBookmarkType = (btBookmark, btKeyInfo, btError, btQuestion);

  TDgError = class
  private
    FLineNumber: Integer;
    FErrorMsg: string;
    FFileName: string;
    FLocalError: Boolean;
    FIsError: Boolean;
    FIsWarning: Boolean;
  public
    property LineNumber: Integer read FLineNumber write FLineNumber;
    property ErrorMsg: string read FErrorMsg write FErrorMsg;
    property FileName: string read FFileName write FFileName;
    property LocalError: Boolean read FLocalError write FLocalError;
    property IsWarning: Boolean read FIsWarning write FIsWarning;
    property IsError: Boolean read FIsError write FIsError;
  end;

  TDgBookmark = class
  private
    FLineNumber: Integer;
    FColNumber: Integer;
    FBookmarkType: TDgBookmarkType;
  public
    constructor Create(LineValue, ColValue: Integer);
    property Line: Integer read FLineNumber write FLineNumber;
    property Col: Integer read FColNumber write FColNumber;
    property BookmarkType: TDgBookmarkType read FBookmarkType write FBookmarkType;
  end;

  TDgTemplate = class(TPersistent)
  private
    FDescription: string;
    FKeyword: string;
    FContent: TStringList;
  public
    constructor Create;
    destructor Destroy; override;
  published
    property Keyword: string read FKeyword write FKeyword;
    property Description: string read FDescription write FDescription;
    property Content: TStringList read FContent write FContent;
  end;

  TDgEnhanceGutter = class(TCustomPanel)
  private
    FPaintBox: TPaintBox;
    FButtonPanel: TPanel;
    FSpeedButton1: TSpeedButton;
    FSpeedButton2: TSpeedButton;
    function GetBtn1ClickEvent: TNotifyEvent;
    function GetBtn2ClickEvent: TNotifyEvent;
    procedure SetBtn1ClickEvent(const Value: TNotifyEvent);
    procedure SetBtn2ClickEvent(const Value: TNotifyEvent);
    function GetPaintBoxClickEvent: TNotifyEvent;
    procedure SetPaintBoxClickEvent(const Value: TNotifyEvent);
    function GetOnPaintBoxMouseMoveEvent: TMouseMoveEvent;
    procedure SetOnPaintBoxMouseMoveEvent(const Value: TMouseMoveEvent);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property PaintBox: TPaintBox read FPaintBox;
    property OnSpeedBtn1ClickEvent: TNotifyEvent read GetBtn1ClickEvent write SetBtn1ClickEvent;
    property OnSpeedBtn2ClickEvent: TNotifyEvent read GetBtn2ClickEvent write SetBtn2ClickEvent;
    property OnPaintBoxClickEvent: TNotifyEvent read GetPaintBoxClickEvent write SetPaintBoxClickEvent;
    property OnPaintBoxMouseMoveEvent: TMouseMoveEvent read GetOnPaintBoxMouseMoveEvent write SetOnPaintBoxMouseMoveEvent;
  end;

  TPasToken = class //(TPersistent)
  private
    FLineNumber: Integer;
    FRunPos: Integer;
    FLinePos: Integer;
    FTokenPos: Integer;
    FTokenLen: Integer;
    FToken: string;
    FTokenID: TptTokenKind;
    FGenID: TptTokenKind;
    FItemIndex: Integer;
    FItemLayer: Integer;
    FMethodLayer: Integer;
    function GetColNumber: Integer;
  public
    property Token: string read FToken write FToken;
    property LineNumber: Integer read FLineNumber write FLineNumber; // Start 0
    property ColNumber: Integer read GetColNumber; // Start 0
    property LinePos: Integer read FLinePos write FLinePos;
    property RunPos: Integer read FRunPos write FRunPos;
    property TokenPos: Integer read FTokenPos write FTokenPos;
    property TokenLen: Integer read FTokenLen write FTokenLen;
    property TokenID: TptTokenKind read FTokenID write FTokenID;
    property GenID: TptTokenKind read FGenID write FGenID;
    property ItemIndex: Integer read FItemIndex write FItemIndex;
    property ItemLayer: Integer read FItemLayer write FItemLayer;
    property MethodLayer: Integer read FMethodLayer write FMethodLayer;
  end;

  ////////////////////////////////////////////////////////////////////////////

  TDgSourceParser = class
  private
    FSource: string;
    FFileName: string;
    FTokenList: TObjectList;
    FImplementation: Boolean;
    FMethodCloseToken: TPasToken;
    FMethodStartToken: TPasToken;
    F_MethodName: string;

    F_Stream: TMemoryStream;
    F_Parser: TmwSimplePasPar;

    procedure OnParsingMessage(Sender: TObject; const Msg: string; X, Y: Integer);
    procedure OnParsing(Sender: TObject; PasLex: TPersistent);
    procedure _ParseSource;
  public
    constructor Create;
    destructor Destroy; override;
    procedure ParseCurrentSource;
    procedure ParseSource(const FileName: string);
    procedure FindCurrentMethodBlock;

    property Tokens: TObjectList read FTokenList;
    property FileName: string read FFileName;
    property _MethodName: string read F_MethodName;
    property MethodStartToken: TPasToken read FMethodStartToken;
    property MethodCloseToken: TPasToken read FMethodCloseToken;
  end;

  TDgHintWindow = class(THintWindow)
  private
    FActivating: Boolean;
    FHintImage: TBitmap;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ActivateHint(Rect: TRect; const AHint: string); override;
  protected
    procedure Paint; override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMNCPaint(var msg: TMessage); message WM_NCPAINT;
  published
    property Caption;
  end;

  ////////////////////////////////////////////////////////////////////////////

var
  SourceParser: TDgSourceParser;

implementation

uses DGUtils, StrUtils;

////////////////////////////////////////////////////////////////////////////////
{ TDgBookmark }

constructor TDgBookmark.Create(LineValue, ColValue: integer);
begin
  inherited Create;
  Line := LineValue;
  Col := ColValue;
  BookmarkType := btBookmark; // Default, not use yet.
end;

////////////////////////////////////////////////////////////////////////////////
{ TDgEnhanceGutter }

constructor TDgEnhanceGutter.Create(AOwner: TComponent);
begin
  inherited;
  BevelOuter := bvLowered;
  BevelInner := bvRaised;
  Width := 30;
  Align := alLeft;

  ParentFont := False;
  FButtonPanel := TPanel.Create(Self);
  with FButtonPanel do
  begin
    Name := 'GutterButtonPanel';
    Parent := Self;
    Align := alBottom;
    Height := 18;
    BevelOuter := bvLowered;
    BevelInner := bvRaised;
    Caption := '';
  end;

  FSpeedButton1 := TSpeedButton.Create(Self);
  with FSpeedButton1 do
  begin
    Name := 'SpeedButton1';
    Parent := FButtonPanel;
    Left := 12;
    Top := 2;
    Width := 12;
    Height := 14;
    Flat := True;
    Caption := 'G';
    Hint := 'Goto Line ...';
    ShowHint := True;
  end;

  FSpeedButton2 := TSpeedButton.Create(Self);
  with FSpeedButton2 do
  begin
    Name := 'SpeedButton2';
    Parent := FButtonPanel;
    Left := 1;
    Top := 2;
    Width := 12;
    Height := 14;
    Flat := True;
    Caption := 'B';
    Hint := 'Add Bookmark ...';
    ShowHint := True;
  end;

  FPaintBox := TPaintBox.Create(Self);
  with FPaintBox do
  begin
    Name := 'GutterPaintBox';
    Parent := Self;
    Align := alClient;
  end;
end;

destructor TDgEnhanceGutter.Destroy;
begin
  FreeAndNil(FSpeedButton1);
  FreeAndNil(FSpeedButton2);
  FreeAndNil(FButtonPanel);
  FreeAndNil(FPaintBox);
  inherited Destroy;
end;

function TDgEnhanceGutter.GetBtn1ClickEvent: TNotifyEvent;
begin
  Result := Self.FSpeedButton1.OnClick;
end;

function TDgEnhanceGutter.GetBtn2ClickEvent: TNotifyEvent;
begin
  Result := Self.FSpeedButton2.OnClick;
end;

function TDgEnhanceGutter.GetOnPaintBoxMouseMoveEvent: TMouseMoveEvent;
begin
  Result := Self.FPaintBox.OnMouseMove;
end;

function TDgEnhanceGutter.GetPaintBoxClickEvent: TNotifyEvent;
begin
  Result := Self.FPaintBox.OnClick;
end;

procedure TDgEnhanceGutter.SetBtn1ClickEvent(const Value: TNotifyEvent);
begin
  Self.FSpeedButton1.OnClick := Value;
end;

procedure TDgEnhanceGutter.SetBtn2ClickEvent(const Value: TNotifyEvent);
begin
  Self.FSpeedButton2.OnClick := Value;
end;

procedure TDgEnhanceGutter.SetOnPaintBoxMouseMoveEvent(
  const Value: TMouseMoveEvent);
begin
  Self.FPaintBox.OnMouseMove := Value;
end;

procedure TDgEnhanceGutter.SetPaintBoxClickEvent(const Value: TNotifyEvent);
begin
  Self.FPaintBox.OnClick := Value;
end;

////////////////////////////////////////////////////////////////////////////////

{ TPasToken }

function TPasToken.GetColNumber: Integer;
begin
  Result := Self.TokenPos - Self.LinePos;
end;

{ TDgSourceParser }

constructor TDgSourceParser.Create;
begin
  inherited;
  FImplementation := False;
  FTokenList := nil;
  F_Stream := TMemoryStream.Create;
  F_Parser := TmwSimplePasPar.Create;
end;

destructor TDgSourceParser.Destroy;
begin
  FTokenList := FreeObjectList(FTokenList);
  FreeAndNil(F_Stream);
  FreeAndNil(F_Parser);
  inherited;
end;

procedure TDgSourceParser.OnParsing(Sender: TObject; PasLex: TPersistent);
var
  Lexer: TmwPasLex;
  Token: TPasToken;
begin
  Lexer := TmwPasLex(PasLex);
  if Lexer.TokenID = ptImplementation then
    FImplementation := True;

  if FImplementation and (Lexer.TokenID <> ptCRLF) then // filter CRLF
  begin
    Token := AssignToken(Lexer);
    Token.ItemIndex := FTokenList.Count;
    FTokenList.Add(Token);
  end;
end;

procedure TDgSourceParser.OnParsingMessage(Sender: TObject;
  const Msg: string; X, Y: Integer);
begin
  //  Do nothing here.
end;

procedure TDgSourceParser.ParseCurrentSource;
var
  FEditBuffer: IOTAEditBuffer;
  TempSource: string;
begin
  FEditBuffer := OTAGetCurrentEditBuffer;
  try
    if Assigned(FEditBuffer) then
    begin
      TempSource := OTAGetEditString(FEditBuffer);
      FFileName := FEditBuffer.FileName;
      if FSource <> TempSource then
      begin
        FSource := TempSource;
        _ParseSource;
      end;
    end;
  finally
    FEditBuffer := nil;
  end;
end;

procedure TDgSourceParser.ParseSource(const FileName: string);
var
  StrList: TStringList;
  TempSource: string;
begin
  Assert(FileExists(FileName), 'Parsing File not found.');

  StrList := TStringList.Create;
  try
    StrList.LoadFromFile(FileName);
    TempSource := StrList.Text;
    FFileName := FileName;
    if FSource <> TempSource then
    begin
      FSource := TempSource;
      _ParseSource;
    end;
  finally
    FreeAndNil(StrList);
  end;
end;

procedure TDgSourceParser.FindCurrentMethodBlock;
var
  i: Integer;
  TempToken: TPasToken;
  CurrentPos: TOTAEditPos;
  CurrentIndex, Count: Integer;

  procedure _BackwardFindDeclarePos();
  var
    i: Integer;
  begin
    for i := MethodCloseToken.ItemIndex downto 0 do
    begin
      TempToken := TPasToken(SourceParser.Tokens.Items[i]);
      case TempToken.TokenID of
        ptProcedure, ptFunction, ptConstructor, ptDestructor:
          begin
            if TempToken.MethodLayer = 0 then
            begin
              FMethodStartToken := TempToken;
              Exit;
            end;
          end;
      end;
    end;
  end;

  procedure _ForwardFindDeclarePos();
  var
    FindEnd: Boolean;
    i: Integer;
  begin
    FindEnd := False;
    Count := Tokens.Count - 1;
    for i := CurrentIndex to Count do
    begin
      TempToken := TPasToken(SourceParser.Tokens.Items[i]);
      case TempToken.TokenID of
        ptProcedure, ptFunction, ptConstructor, ptDestructor:
          begin
            if TempToken.MethodLayer = 0 then
              if FindEnd then
                Exit;
          end;
        ptInitialization, ptFinalization: if FindEnd then Break;
        ptEnd:
          begin
            FindEnd := True;
            FMethodCloseToken := TempToken;
          end;
      end;
    end;
  end;

  procedure _GetMethodName;
  var
    i: Integer;
  begin
    for i := MethodStartToken.ItemIndex + 1 to MethodCloseToken.ItemIndex do
    begin
      TempToken := TPasToken(SourceParser.Tokens.Items[i]);
      if (TempToken.Token = '(') or (TempToken.Token = ':') or (TempToken.Token = ';') then
        Break;
      F_MethodName := F_MethodName + Trim(TempToken.Token);
    end;
  end;

begin
  FMethodStartToken := nil;
  FMethodCloseToken := nil;
  F_MethodName := '';
  if OTAGetCursorPos(CurrentPos) then
  begin
    Count := Tokens.Count - 1;
    for i := 0 to Count do
      if CurrentPos.Line <= TPasToken(SourceParser.Tokens.Items[i]).LineNumber + 1 then
        Break;
    CurrentIndex := i;
    _ForwardFindDeclarePos;
    _BackwardFindDeclarePos;
    try
      _GetMethodName;
    except
    end;
  end;
end;

procedure TDgSourceParser._ParseSource;
var
  StrStream: TStringStream;
  i, Layer, MethodLayer, Count: Integer;
  TempToken: TPasToken;
  Stack: TObjectStack;
begin
  FTokenList := ClearObjectList(FTokenList);
  Assert(Assigned(FTokenList), 'The TokenList is nil.');

  StrStream := TStringStream.Create(FSource);
  try
    F_Stream.LoadFromStream(StrStream);
    F_Stream.Position := 0;
    F_Parser.OnMessage := OnParsingMessage;
    F_Parser.OnParsing := OnParsing;
    F_Parser.Run('', F_Stream);
  finally
    FreeAndNil(StrStream);
  end;
  FImplementation := False;

  Stack := TObjectStack.Create;
  try
    Layer := 0;
    MethodLayer := 0;
    Count := FTokenList.Count - 1;
    for i := 0 to Count do
    begin
      TempToken := TPasToken(FTokenList.Items[i]);
      case TempToken.TokenID of
        ptProcedure, ptFunction, ptConstructor, ptDestructor:
          begin
            TempToken.ItemLayer := Layer;
            TempToken.MethodLayer := MethodLayer;
            Inc(MethodLayer);
            Stack.Push(TempToken);
          end;
        ptBegin, ptAsm:
          begin
            if Layer = 0 then
            begin
              TempToken.MethodLayer := TPasToken(Stack.Pop).MethodLayer;
              Dec(MethodLayer);
            end;
            Inc(Layer);
            TempToken.ItemLayer := Layer;
          end;
        ptCase, ptTry, ptRepeat, ptIf, ptFor, ptWith, ptOn, ptWhile:
          begin
            Inc(Layer);
            TempToken.ItemLayer := Layer;
          end;
        ptEnd, ptUntil, ptThen, ptDo:
          begin
            TempToken.ItemLayer := Layer;
            Dec(Layer);
          end;
      else
        TempToken.ItemLayer := Layer;
      end;
{$IFDEF ENABLE_PARSING_CSDEBUG}
      Debug(Format('{%d, %d}, %d, %d, "%s"', [TempToken.LineNumber + 1,
        TempToken.TokenPos - TempToken.LinePos + 1, Layer, TempToken.MethodLayer, TempToken.Token]), TempToken);
{$ENDIF}
    end;
    // Debug('Last Layer is -1?', Layer);
  finally
    FreeAndNil(Stack);
  end;
end;

{ TDgOptions }

constructor TDgOptions.Create;
begin
  inherited;
  Gutters := TDgGutterOptions.Create;
  Templates := TDgCodeTemplateOptions.Create;
  Matchs := TDgTokenMatchOptions.Create;
  Syntaxs := TDgSyntaxErrorOptions.Create;
end;

destructor TDgOptions.Destroy;
begin
  FreeAndNil(Syntaxs);
  FreeAndNil(Matchs);
  FreeAndNil(Templates);
  FreeAndNil(Gutters);
  inherited Destroy;
end;

{ TDgCodeTemplateOptions }

constructor TDgCodeTemplateOptions.Create;
begin
  inherited;
  FTemplateObjects := DGUtils.ClearObjectList(nil);
end;

destructor TDgCodeTemplateOptions.Destroy;
begin
  DGUtils.FreeObjectList(FTemplateObjects);
  inherited;
end;

function TDgCodeTemplateOptions.GetTemplateContentFromKey(const TemplateKey: string): string;
var
  i: Integer;
  Temp: string;
  TemplateObj: TDgTemplate;
begin
  Result := '';
  Temp := UpperCase(TemplateKey);
  for i := 0 to FTemplateObjects.Count - 1 do
  begin
    TemplateObj := FTemplateObjects.Items[i] as TDgTemplate;
    // Debug('Parsing: ' + TemplateObj.Keyword + ' ' + TemplateObj.Description, TemplateObj.Content);
    if UpperCase(TemplateObj.Keyword) = Temp then
    begin
      Result := TemplateObj.Content.Text;
      Break;
    end;
  end;

  //  Delete Last CRLF (#13#10)
  while Ord(Result[Length(Result)]) = 10 do
    Result := Copy(Result, 1, Length(Result) - 2);
end;

function IsBeginRecord(line: string): boolean;
var
  s: string;
begin
  s := trim(line);
  result := false;
  if ((copy(s, 0, 1) = '[') and (copy(s, Length(s), 1) = ']')) then
    result := true;
end;

function GetKeyword(line: string): string;
begin
  result := trim(copy(line, 2, pos('|', line) - 2));
end;

function GetDescription(line: string): string;
begin
  result := trim(copy(line, pos('|', line) + 1, Length(line) - pos('|', line) - 1));
end;

procedure PackStringList(sl: TStringList);
var
  i: integer;
begin
  for i := sl.Count - 1 downto 0 do
  begin
    if trim(sl[i]) + 'A' = 'A' then
      sl.Delete(i)
    else
      break;
  end;
end;

function _SortTemplateObjects(Item1, Item2: Pointer): Integer;
begin
  Result := CompareStr(TDgTemplate(Item1).Keyword, TDgTemplate(Item2).Keyword);
end;

procedure TDgCodeTemplateOptions.GetTemplates;
var
  TemplateFile: string;

  FileStrs: TStringList;
  _Content: TStringList;
  sTemp, _Keyword, _Description: string;
  i: Integer;
  TemplateObj: TDgTemplate;

begin
  DebugAddSeparator;
  TemplateFile := DGUtils.GetDelphi7RootDir + 'BIN\DELPHI32.DCI';
  Debug('Parsing Delphi Template File', TemplateFile);

  FTemplateObjects := ClearObjectList(FTemplateObjects);
  FileStrs := TStringList.Create();
  _Content := TStringList.Create();
  _Keyword := '';
  _Description := '';
  try
    FileStrs.LoadFromFile(TemplateFile);
    for i := 0 to FileStrs.Count - 1 do
    begin
      sTemp := TrimRight(FileStrs.Strings[i]);
      if IsBeginRecord(sTemp) then
      begin
        if (Length(_Keyword) > 0) and (UpperCase(RightStr(_Description, 6)) = 'PASCAL') then
        try
          PackStringList(_Content);
          TemplateObj := TDgTemplate.Create;
          TemplateObj.Keyword := _Keyword;
          TemplateObj.Description := _Description;
          TemplateObj.Content.Text := _Content.Text;

          FTemplateObjects.Add(TemplateObj);
          Debug('Parsing: ' + TemplateObj.Keyword + ' ' + TemplateObj.Description, TemplateObj.Content);
        except
        end;
        _Content.Clear();
        _Keyword := GetKeyword(sTemp);
        _Description := GetDescription(sTemp);
      end
      else
        _Content.Append(FileStrs.Strings[i]);
    end;

    //  һûȥ
    if Length(_Content.Text) > 0 then
    try
      PackStringList(_Content);
      TemplateObj := TDgTemplate.Create;
      TemplateObj.Keyword := _Keyword;
      TemplateObj.Description := _Description;
      TemplateObj.Content.Text := _Content.Text;

      FTemplateObjects.Add(TemplateObj);
      Debug('Parsing: ' + TemplateObj.Keyword + ' ' + TemplateObj.Description, TemplateObj.Content);
    except
    end;

  finally
    FreeAndNil(FileStrs);
    FreeAndNil(_Content);
  end;
  try
    FTemplateObjects.Sort(@_SortTemplateObjects);
  except
  end;
  DebugAddSeparator;
end;

/////////////////////////////////////////////////////////////////////////////////

procedure TDgHintWindow.ActivateHint(Rect: TRect; const AHint: string);
begin
  FActivating := True;
  try
    Caption := AHint;
    Inc(Rect.Bottom, 14);
    Rect.Right := Rect.Right + 25;
    UpdateBoundsRect(Rect);
    if Rect.Top + Height > Screen.DesktopHeight then
      Rect.Top := Screen.DesktopHeight - Height;
    if Rect.Left + Width > Screen.DesktopWidth then
      Rect.Left := Screen.DesktopWidth - Width;
    if Rect.Left < Screen.DesktopLeft then
      Rect.Left := Screen.DesktopLeft;
    if Rect.Bottom < Screen.DesktopTop then
      Rect.Bottom := Screen.DesktopTop;
    SetWindowPos(Handle, HWND_TOPMOST, Rect.Left, Rect.Top, Width, Height,
      SWP_SHOWWINDOW or SWP_NOACTIVATE);
    Invalidate;
  finally
    FActivating := False;
  end;
end;

constructor TDgHintWindow.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FHintImage := TBitmap.Create;
  FHintImage.Width := 16;
  FHintImage.Height := 16;
  DgUtils.LoadBitmapFromRes('Hint', FHintImage);

  with Canvas.Font do
  begin
    Name := 'Tahoma';
    Size := 8;
    Style := Style + [fsBold];
    Color := clRed;
  end;
end;

procedure TDgHintWindow.CreateParams(var Params: TCreateParams);
const
  CS_DROPSHADOW = $00020000;
begin
  inherited;
  Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

destructor TDgHintWindow.Destroy;
begin
  FreeAndNil(FHintImage);
  inherited;
end;

procedure TDgHintWindow.Paint;
var
  R: TRect;
begin
  R := ClientRect;
  Inc(R.Left, 2);
  Inc(R.Top, 2);

  with Canvas do
  begin
    Brush.Style := bsSolid;
    Brush.Color := clsilver;
    Pen.Color := clgray;
    Rectangle(0, 0, 18, R.Bottom + 1);
    Draw(2, (R.Bottom div 2) - (FHintImage.Height div 2), FHintImage);
  end;

  //custom Hint Color
  Color := clWhite;
  Canvas.Brush.Style := bsClear;
  Canvas.TextOut(20, (R.Bottom div 2) - (Canvas.Textheight(Caption) div 2), Caption);
end;

procedure TDgHintWindow.WMNCPaint(var msg: TMessage);
var
  R: TRect;
  DC: HDC;
begin
  DC := GetWindowDC(Handle);
  try
    R := Rect(0, 0, Width, Height);
    DrawEdge(DC, R, EDGE_ETCHED, BF_RECT or BF_MONO);
  finally
    ReleaseDC(Handle, DC);
  end;
end;

{ TDgTemplate }

constructor TDgTemplate.Create;
begin
  inherited;
  FContent := TStringList.Create;
end;

destructor TDgTemplate.Destroy;
begin
  FreeAndNil(FContent);
  inherited;
end;

initialization
  SourceParser := TDgSourceParser.Create;

finalization
  FreeAndNil(SourceParser);

end.

